// tamil.h

#ifndef TAMIL_H
#define TAMIL_H



typedef struct {
   const wchar_t *szUnicode ;
   const char    *szTscii ;
   const char    *szTab ;
   const char    *szTam ;
} TAMIL_EQUIVALENT_TABLE ;



const TAMIL_EQUIVALENT_TABLE *UnicodeToTamil ( const wchar_t *szSrc ) ;
const TAMIL_EQUIVALENT_TABLE *TamilToUnicode ( const char *szSrc, int nSrcCodePage ) ;



#endif


