// viettable.h

#ifndef VIETTABLE_H
#define VIETTABLE_H


#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#pragma setlocale ( "C" )
#endif



static const VIET_EQUIVALENT_TABLE VietEquivalentTable [] = {
//                TCVN  VSCI  VPS   WIN         [A1][2]           [A2][1]           [A][1][2]               VNI         VIQR              VIQR alt
// { 0x0001,   /* 0,    0x01, 0x01, 0x01, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0002,   /* 0,    0,    0,    0x02, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0003,   /* 0x03, 0x03, 0,    0x03, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0004,   /* 0,    0x04, 0,    0x04, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0005,   /* 0,    0,    0,    0x05, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0006,   /* 0,    0,    0,    0x06, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0007,   /* 0x07, 0x07, 0x07, 0x07, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0008,   /* 0x08, 0x08, 0x08, 0x08, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0009,   /* 0x09, 0x09, 0x09, 0x09, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000A,   /* 0x0A, 0x0A, 0x0A, 0x0A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000B,   /* 0x0B, 0x0B, 0x0B, 0x0B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000C,   /* 0x0C, 0x0C, 0x0C, 0x0C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000D,   /* 0x0D, 0x0D, 0x0D, 0x0D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000E,   /* 0x0E, 0x0E, 0x0E, 0x0E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x000F,   /* 0x0F, 0x0F, 0x0F, 0x0F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0010,   /* 0x10, 0x10, 0,    0x10, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0011,   /* 0,    0x11, 0,    0x11, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0012,   /* 0,    0x12, 0,    0x12, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0013,   /* 0,    0x13, 0,    0x13, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0014,   /* 0,    0,    0,    0x14, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0015,   /* 0,    0x15, 0,    0x15, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0016,   /* 0,    0x16, 0x16, 0x16, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0017,   /* 0,    0x17, 0x17, 0x17, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0018,   /* 0x18, 0x18, 0x18, 0x18, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0019,   /* 0x19, 0,    0,    0x19, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001A,   /* 0x1A, 0x1A, 0x1A, 0x1A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001B,   /* 0x1B, 0x1B, 0x1B, 0x1B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001C,   /* 0x1C, 0x1C, 0,    0x1C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001D,   /* 0x1D, 0x1D, 0,    0x1D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001E,   /* 0x1E, 0,    0x1E, 0x1E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x001F,   /* 0x1F, 0x1F, 0x1F, 0x1F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0020,   /* 0x20, 0x20, 0x20, 0x20, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0021,   /* 0x21, 0x21, 0x21, 0x21, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0022,   /* 0x22, 0x22, 0x22, 0x22, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0023,   /* 0x23, 0x23, 0x23, 0x23, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0024,   /* 0x24, 0x24, 0x24, 0x24, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0025,   /* 0x25, 0x25, 0x25, 0x25, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0026,   /* 0x26, 0x26, 0x26, 0x26, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0027,   /* 0x27, 0x27, 0x27, 0x27, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0028,   /* 0x28, 0x28, 0x28, 0x28, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0029,   /* 0x29, 0x29, 0x29, 0x29, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002A,   /* 0x2A, 0x2A, 0x2A, 0x2A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002B,   /* 0x2B, 0x2B, 0x2B, 0x2B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002C,   /* 0x2C, 0x2C, 0x2C, 0x2C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002D,   /* 0x2D, 0x2D, 0x2D, 0x2D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002E,   /* 0x2E, 0x2E, 0x2E, 0x2E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x002F,   /* 0x2F, 0x2F, 0x2F, 0x2F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0030,   /* 0x30, 0x30, 0x30, 0x30, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0031,   /* 0x31, 0x31, 0x31, 0x31, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0032,   /* 0x32, 0x32, 0x32, 0x32, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0033,   /* 0x33, 0x33, 0x33, 0x33, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0034,   /* 0x34, 0x34, 0x34, 0x34, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0035,   /* 0x35, 0x35, 0x35, 0x35, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0036,   /* 0x36, 0x36, 0x36, 0x36, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0037,   /* 0x37, 0x37, 0x37, 0x37, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0038,   /* 0x38, 0x38, 0x38, 0x38, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0039,   /* 0x39, 0x39, 0x39, 0x39, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003A,   /* 0x3A, 0x3A, 0x3A, 0x3A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003B,   /* 0x3B, 0x3B, 0x3B, 0x3B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003C,   /* 0x3C, 0x3C, 0x3C, 0x3C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003D,   /* 0x3D, 0x3D, 0x3D, 0x3D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003E,   /* 0x3E, 0x3E, 0x3E, 0x3E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x003F,   /* 0x3F, 0x3F, 0x3F, 0x3F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0040,   /* 0x40, 0x40, 0x40, 0x40, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0041,   /* 0x41, 0x41, 0x41, 0x41, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0042,   /* 0x42, 0x42, 0x42, 0x42, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0043,   /* 0x43, 0x43, 0x43, 0x43, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0044,   /* 0x44, 0x44, 0x44, 0x44, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0045,   /* 0x45, 0x45, 0x45, 0x45, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0046,   /* 0x46, 0x46, 0x46, 0x46, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0047,   /* 0x47, 0x47, 0x47, 0x47, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0048,   /* 0x48, 0x48, 0x48, 0x48, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0049,   /* 0x49, 0x49, 0x49, 0x49, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004A,   /* 0x4A, 0x4A, 0x4A, 0x4A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004B,   /* 0x4B, 0x4B, 0x4B, 0x4B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004C,   /* 0x4C, 0x4C, 0x4C, 0x4C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004D,   /* 0x4D, 0x4D, 0x4D, 0x4D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004E,   /* 0x4E, 0x4E, 0x4E, 0x4E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x004F,   /* 0x4F, 0x4F, 0x4F, 0x4F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0050,   /* 0x50, 0x50, 0x50, 0x50, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0051,   /* 0x51, 0x51, 0x51, 0x51, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0052,   /* 0x52, 0x52, 0x52, 0x52, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0053,   /* 0x53, 0x53, 0x53, 0x53, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0054,   /* 0x54, 0x54, 0x54, 0x54, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0055,   /* 0x55, 0x55, 0x55, 0x55, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0056,   /* 0x56, 0x56, 0x56, 0x56, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0057,   /* 0x57, 0x57, 0x57, 0x57, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0058,   /* 0x58, 0x58, 0x58, 0x58, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0059,   /* 0x59, 0x59, 0x59, 0x59, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005A,   /* 0x5A, 0x5A, 0x5A, 0x5A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005B,   /* 0x5B, 0x5B, 0x5B, 0x5B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005C,   /* 0x5C, 0x5C, 0x5C, 0x5C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005D,   /* 0x5D, 0x5D, 0x5D, 0x5D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005E,   /* 0x5E, 0x5E, 0x5E, 0x5E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x005F,   /* 0x5F, 0x5F, 0x5F, 0x5F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0060,   /* 0x60, 0x60, 0x60, 0x60, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0061,   /* 0x61, 0x61, 0x61, 0x61, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0062,   /* 0x62, 0x62, 0x62, 0x62, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0063,   /* 0x63, 0x63, 0x63, 0x63, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0064,   /* 0x64, 0x64, 0x64, 0x64, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0065,   /* 0x65, 0x65, 0x65, 0x65, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0066,   /* 0x66, 0x66, 0x66, 0x66, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0067,   /* 0x67, 0x67, 0x67, 0x67, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0068,   /* 0x68, 0x68, 0x68, 0x68, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0069,   /* 0x69, 0x69, 0x69, 0x69, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006A,   /* 0x6A, 0x6A, 0x6A, 0x6A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006B,   /* 0x6B, 0x6B, 0x6B, 0x6B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006C,   /* 0x6C, 0x6C, 0x6C, 0x6C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006D,   /* 0x6D, 0x6D, 0x6D, 0x6D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006E,   /* 0x6E, 0x6E, 0x6E, 0x6E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x006F,   /* 0x6F, 0x6F, 0x6F, 0x6F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0070,   /* 0x70, 0x70, 0x70, 0x70, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0071,   /* 0x71, 0x71, 0x71, 0x71, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0072,   /* 0x72, 0x72, 0x72, 0x72, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0073,   /* 0x73, 0x73, 0x73, 0x73, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0074,   /* 0x74, 0x74, 0x74, 0x74, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0075,   /* 0x75, 0x75, 0x75, 0x75, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0076,   /* 0x76, 0x76, 0x76, 0x76, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0077,   /* 0x77, 0x77, 0x77, 0x77, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0078,   /* 0x78, 0x78, 0x78, 0x78, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0079,   /* 0x79, 0x79, 0x79, 0x79, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007A,   /* 0x7A, 0x7A, 0x7A, 0x7A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007B,   /* 0x7B, 0x7B, 0x7B, 0x7B, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007C,   /* 0x7C, 0x7C, 0x7C, 0x7C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007D,   /* 0x7D, 0x7D, 0x7D, 0x7D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007E,   /* 0x7E, 0x7E, 0x7E, 0x7E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x007F,   /* 0x7F, 0x7F, 0x7F, 0x7F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0081,   /* 0,    0,    0,    0x81, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x008A,   /* 0,    0,    0,    0x8A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x008D,   /* 0,    0,    0,    0x8D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x008E,   /* 0,    0,    0,    0x8E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x008F,   /* 0,    0,    0,    0x8F, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0090,   /* 0,    0,    0,    0x90, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x009A,   /* 0,    0,    0,    0x9A, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x009D,   /* 0,    0,    0,    0x9D, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x009E,   /* 0,    0,    0,    0x9E, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A0,   /* 0xA0, 0,    0xA0, 0xA0, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A1,   /* 0,    0,    0,    0xA1, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A2,   /* 0,    0,    0,    0xA2, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A3,   /* 0,    0,    0,    0xA3, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A4,   /* 0,    0,    0,    0xA4, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A5,   /* 0,    0,    0,    0xA5, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A6,   /* 0,    0,    0,    0xA6, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A7,   /* 0,    0,    0,    0xA7, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A8,   /* 0,    0,    0,    0xA8, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00A9,   /* 0,    0,    0,    0xA9, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AA,   /* 0,    0,    0,    0xAA, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AB,   /* 0,    0,    0,    0xAB, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AC,   /* 0,    0,    0,    0xAC, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AD,   /* 0,    0,    0,    0xAD, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AE,   /* 0,    0,    0,    0xAE, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00AF,   /* 0,    0,    0,    0xAF, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B0,   /* 0,    0,    0,    0xB0, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B1,   /* 0,    0,    0,    0xB1, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B2,   /* 0,    0,    0,    0xB2, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B3,   /* 0,    0,    0,    0xB3, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B4,   /* 0,    0,    0,    0xB4, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B5,   /* 0,    0,    0,    0xB5, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B6,   /* 0,    0,    0,    0xB6, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B7,   /* 0,    0,    0,    0xB7, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B8,   /* 0,    0,    0,    0xB8, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00B9,   /* 0,    0,    0,    0xB9, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BA,   /* 0,    0,    0,    0xBA, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BB,   /* 0,    0,    0,    0xBB, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BC,   /* 0,    0,    0,    0xBC, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BD,   /* 0,    0,    0,    0xBD, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BE,   /* 0,    0,    0,    0xBE, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00BF,   /* 0,    0,    0,    0xBF, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00C0,   /* 0x80, 0xC0, 0x80, 0xC0, */    NULL,             NULL,             L"\x0041\x0300",        "\x41\xD8", "\x41\x60",       NULL,       } ,
   { 0x00C1,   /* 0x83, 0xC1, 0xC1, 0xC1, */    NULL,             NULL,             L"\x0041\x0301",        "\x41\xD9", "\x41\x27",       NULL,       } ,
   { 0x00C2,   /* 0xA2, 0xC2, 0xC2, 0xC2, */    NULL,             NULL,             L"\x0041\x0302",        "\x41\xC2", "\x41\x5E",       NULL,       } ,
   { 0x00C3,   /* 0x82, 0xC3, 0x82, 0,    */    L"\x0041\x0303",  NULL,             NULL,                   "\x41\xD5", "\x41\x7E",       NULL,       } ,
   { 0x00C4,   /* 0,    0,    0,    0xC4, */    NULL,             NULL,             L"\x0041\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00C5,   /* 0,    0,    0,    0xC5, */    NULL,             NULL,             L"\x0041\x030A",        NULL,       NULL,             NULL,       } ,
// { 0x00C6,   /* 0,    0,    0,    0xC6, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00C7,   /* 0,    0,    0,    0xC7, */    NULL,             NULL,             L"\x0043\x0327",        NULL,       NULL,             NULL,       } ,
   { 0x00C8,   /* 0x87, 0xC8, 0xD7, 0xC8, */    NULL,             NULL,             L"\x0045\x0300",        "\x45\xD8", "\x45\x60",       NULL,       } ,
   { 0x00C9,   /* 0x8A, 0xC9, 0xC9, 0xC9, */    NULL,             NULL,             L"\x0045\x0301",        "\x45\xD9", "\x45\x27",       NULL,       } ,
   { 0x00CA,   /* 0xA3, 0xCA, 0xCA, 0xCA, */    NULL,             NULL,             L"\x0045\x0302",        "\x45\xC2", "\x45\x5E",       NULL,       } ,
   { 0x00CB,   /* 0,    0,    0,    0xCB, */    NULL,             NULL,             L"\x0045\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00CC,   /* 0x8D, 0xCC, 0xB5, 0,    */    L"\x0049\x0300",  NULL,             NULL,                   NULL,       "\x49\x60",       NULL,       } ,
   { 0x00CD,   /* 0x90, 0xCD, 0xB4, 0xCD, */    NULL,             NULL,             L"\x0049\x0301",        NULL,       "\x49\x27",       NULL,       } ,
   { 0x00CE,   /* 0,    0,    0,    0xCE, */    NULL,             NULL,             L"\x0049\x0302",        "\x49\xC2", NULL,             NULL,       } ,
   { 0x00CF,   /* 0,    0,    0,    0xCF, */    NULL,             NULL,             L"\x0049\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00D1,   /* 0,    0,    0,    0xD1, */    NULL,             NULL,             L"\x004E\x0303",        "\x4E\xD5", NULL,             NULL,       } ,
   { 0x00D2,   /* 0x92, 0xD2, 0xBC, 0,    */    L"\x004F\x0300",  NULL,             NULL,                   "\x4F\xD8", "\x4F\x60",       NULL,       } ,
   { 0x00D3,   /* 0x95, 0xD3, 0xB9, 0xD3, */    NULL,             NULL,             L"\x004F\x0301",        "\x4F\xD9", "\x4F\x27",       NULL,       } ,
   { 0x00D4,   /* 0xA4, 0xD4, 0xD4, 0xD4, */    NULL,             NULL,             L"\x004F\x0302",        "\x4F\xC2", "\x4F\x5E",       NULL,       } ,
   { 0x00D5,   /* 0x94, 0xA0, 0xBE, 0,    */    L"\x004F\x0303",  NULL,             NULL,                   "\x4F\xD5", "\x4F\x7E",       NULL,       } ,
   { 0x00D6,   /* 0,    0,    0,    0xD6, */    NULL,             NULL,             L"\x004F\x0308",        NULL,       NULL,             NULL,       } ,
// { 0x00D7,   /* 0,    0,    0,    0xD7, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00D8,   /* 0,    0,    0,    0xD8, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00D9,   /* 0x9D, 0xD9, 0xA8, 0xD9, */    NULL,             NULL,             L"\x0055\x0300",        "\x55\xD8", "\x55\x60",       NULL,       } ,
   { 0x00DA,   /* 0x01, 0xDA, 0xDA, 0xDA, */    NULL,             NULL,             L"\x0055\x0301",        "\x55\xD9", "\x55\x27",       NULL,       } ,
   { 0x00DB,   /* 0,    0,    0,    0xDB, */    NULL,             NULL,             L"\x0055\x0302",        "\x55\xC2", NULL,             NULL,       } ,
   { 0x00DC,   /* 0,    0,    0,    0xDC, */    NULL,             NULL,             L"\x0055\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00DD,   /* 0x16, 0xDD, 0xDD, 0,    */    L"\x0059\x0301",  NULL,             NULL,                   "\x59\xD9", "\x59\x27",       NULL,       } ,
// { 0x00DF,   /* 0,    0,    0xDF, 0xDF, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00E0,   /* 0xB5, 0xE0, 0xE0, 0xE0, */    NULL,             NULL,             L"\x0061\x0300",        "\x61\xF8", "\x61\x60",       NULL,       } ,
   { 0x00E1,   /* 0xB8, 0xE1, 0xE1, 0xE1, */    NULL,             NULL,             L"\x0061\x0301",        "\x61\xF9", "\x61\x27",       NULL,       } ,
   { 0x00E2,   /* 0xA9, 0xE2, 0xE2, 0xE2, */    NULL,             NULL,             L"\x0061\x0302",        "\x61\xE2", "\x61\x5E",       NULL,       } ,
   { 0x00E3,   /* 0xB7, 0xE3, 0xE3, 0,    */    L"\x0061\x0303",  NULL,             NULL,                   "\x61\xF5", "\x61\x7E",       NULL,       } ,
   { 0x00E4,   /* 0,    0,    0,    0xE4, */    NULL,             NULL,             L"\x0061\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00E5,   /* 0,    0,    0,    0xE5, */    NULL,             NULL,             L"\x0061\x030A",        NULL,       NULL,             NULL,       } ,
// { 0x00E6,   /* 0,    0,    0,    0xE6, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00E7,   /* 0,    0,    0xE7, 0xE7, */    NULL,             NULL,             L"\x0063\x0327",        NULL,       NULL,             NULL,       } ,
   { 0x00E8,   /* 0xCC, 0xE8, 0xE8, 0xE8, */    NULL,             NULL,             L"\x0065\x0300",        "\x65\xF8", "\x65\x60",       NULL,       } ,
   { 0x00E9,   /* 0xD0, 0xE9, 0xE9, 0xE9, */    NULL,             NULL,             L"\x0065\x0301",        "\x65\xF9", "\x65\x27",       NULL,       } ,
   { 0x00EA,   /* 0xAA, 0xEA, 0xEA, 0xEA, */    NULL,             NULL,             L"\x0065\x0302",        "\x65\xE2", "\x65\x5E",       NULL,       } ,
   { 0x00EB,   /* 0,    0,    0,    0xEB, */    NULL,             NULL,             L"\x0065\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00EC,   /* 0xD7, 0xEC, 0xEC, 0,    */    L"\x0069\x0300",  NULL,             NULL,                   NULL,       "\x69\x60",       NULL,       } ,
   { 0x00ED,   /* 0xDD, 0xED, 0xED, 0xED, */    NULL,             NULL,             L"\x0069\x0301",        NULL,       "\x69\x27",       NULL,       } ,
   { 0x00EE,   /* 0,    0,    0xEE, 0xEE, */    NULL,             NULL,             L"\x0069\x0302",        NULL,       NULL,             NULL,       } ,
   { 0x00EF,   /* 0,    0,    0,    0xEF, */    NULL,             NULL,             L"\x0069\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00F1,   /* 0,    0,    0,    0xF1, */    NULL,             NULL,             L"\x006E\x0303",        "\x6E\xF5", NULL,             NULL,       } ,
   { 0x00F2,   /* 0xDF, 0xF2, 0xF2, 0,    */    L"\x006F\x0300",  NULL,             NULL,                   "\x6F\xF8", "\x6F\x60",       NULL,       } ,
   { 0x00F3,   /* 0xE3, 0xF3, 0xF3, 0xF3, */    NULL,             NULL,             L"\x006F\x0301",        "\x6F\xF9", "\x6F\x27",       NULL,       } ,
   { 0x00F4,   /* 0xAB, 0xF4, 0xF4, 0xF4, */    NULL,             NULL,             L"\x006F\x0302",        "\x6F\xE2", "\x6F\x5E",       NULL,       } ,
   { 0x00F5,   /* 0xE2, 0xF5, 0xF5, 0,    */    L"\x006F\x0303",  NULL,             NULL,                   "\x6F\xF5", "\x6F\x7E",       NULL,       } ,
   { 0x00F6,   /* 0,    0,    0xF6, 0xF6, */    NULL,             NULL,             L"\x006F\x0308",        NULL,       NULL,             NULL,       } ,
// { 0x00F7,   /* 0,    0,    0,    0xF7, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x00F8,   /* 0,    0,    0,    0xF8, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x00F9,   /* 0xEF, 0xF9, 0xF9, 0xF9, */    NULL,             NULL,             L"\x0075\x0300",        "\x75\xF8", "\x75\x60",       NULL,       } ,
   { 0x00FA,   /* 0xF3, 0xFA, 0xFA, 0xFA, */    NULL,             NULL,             L"\x0075\x0301",        "\x75\xF9", "\x75\x27",       NULL,       } ,
   { 0x00FB,   /* 0,    0,    0,    0xFB, */    NULL,             NULL,             L"\x0075\x0302",        "\x75\xE2", NULL,             NULL,       } ,
   { 0x00FC,   /* 0,    0,    0xFC, 0xFC, */    NULL,             NULL,             L"\x0075\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x00FD,   /* 0xFD, 0xFD, 0x9A, 0,    */    L"\x0079\x0301",  NULL,             NULL,                   "\x79\xF9", "\x79\x27",       NULL,       } ,
   { 0x00FF,   /* 0,    0,    0,    0xFF, */    NULL,             NULL,             L"\x0079\x0308",        NULL,       NULL,             NULL,       } ,
   { 0x0102,   /* 0xA1, 0xC5, 0x88, 0xC3, */    NULL,             NULL,             L"\x0041\x0306",        "\x41\xCA", "\x41\x28",       NULL,       } ,
   { 0x0103,   /* 0xA8, 0xE5, 0xE6, 0xE3, */    NULL,             NULL,             L"\x0061\x0306",        "\x61\xEA", "\x61\x28",       NULL,       } ,
   { 0x0110,   /* 0xA7, 0xD0, 0xF1, 0xD0, */    NULL,             NULL,             NULL,                   NULL,       "\x44\x44",       NULL,       } ,
   { 0x0111,   /* 0xAE, 0xF0, 0xC7, 0xF0, */    NULL,             NULL,             NULL,                   NULL,       "\x64\x64",       NULL,       } ,
   { 0x0128,   /* 0x8F, 0xCE, 0xB8, 0,    */    L"\x0049\x0303",  NULL,             NULL,                   NULL,       "\x49\x7E",       NULL,       } ,
   { 0x0129,   /* 0xDC, 0xEE, 0xEF, 0,    */    L"\x0069\x0303",  NULL,             NULL,                   NULL,       "\x69\x7E",       NULL,       } ,
// { 0x0152,   /* 0,    0,    0,    0x8C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0153,   /* 0,    0,    0,    0x9C, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x0168,   /* 0x9F, 0x9D, 0xAC, 0,    */    L"\x0055\x0303",  NULL,             NULL,                   "\x55\xD5", "\x55\x7E",       NULL,       } ,
   { 0x0169,   /* 0xF2, 0xFB, 0xDB, 0,    */    L"\x0075\x0303",  NULL,             NULL,                   "\x75\xF5", "\x75\x7E",       NULL,       } ,
   { 0x0178,   /* 0,    0,    0,    0x9F, */    NULL,             NULL,             L"\x0059\x0308",        NULL,       NULL,             NULL,       } ,
// { 0x0192,   /* 0,    0,    0,    0x83, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x01A0,   /* 0xA5, 0xB4, 0xF7, 0xD5, */    NULL,             NULL,             L"\x004F\x031B",        NULL,       "\x4F\x2B",       NULL,       } ,
   { 0x01A1,   /* 0xAC, 0xBD, 0xD6, 0xF5, */    NULL,             NULL,             L"\x006F\x031B",        NULL,       "\x6F\x2B",       NULL,       } ,
   { 0x01AF,   /* 0xA6, 0xBF, 0xD0, 0xDD, */    NULL,             NULL,             L"\x0055\x031B",        NULL,       "\x55\x2B",       NULL,       } ,
   { 0x01B0,   /* 0xAD, 0xDF, 0xDC, 0xFD, */    NULL,             NULL,             L"\x0075\x031B",        NULL,       "\x75\x2B",       NULL,       } ,
// { 0x02C6,   /* 0,    0,    0,    0x88, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x02DC,   /* 0,    0,    0,    0x98, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0300,   /* 0xB0, 0,    0,    0xCC, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0301,   /* 0xB3, 0,    0,    0xEC, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0303,   /* 0xB2, 0,    0,    0xDE, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0309,   /* 0xB1, 0,    0,    0xD2, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
// { 0x0323,   /* 0xB4, 0,    0,    0xF2, */    NULL,             NULL,             NULL,                   NULL,       NULL,             NULL,       } ,
   { 0x1EA0,   /* 0x84, 0x80, 0x02, 0,    */    L"\x0041\x0323",  NULL,             NULL,                   "\x41\xCF", "\x41\x2E",       NULL,       } ,
   { 0x1EA1,   /* 0xB9, 0xD5, 0xE5, 0,    */    L"\x0061\x0323",  NULL,             NULL,                   "\x61\xEF", "\x61\x2E",       NULL,       } ,
   { 0x1EA2,   /* 0x81, 0xC4, 0x81, 0,    */    L"\x0041\x0309",  NULL,             NULL,                   "\x41\xDB", "\x41\x3F",       NULL,       } ,
   { 0x1EA3,   /* 0xB6, 0xE4, 0xE4, 0,    */    L"\x0061\x0309",  NULL,             NULL,                   "\x61\xFB", "\x61\x3F",       NULL,       } ,
   { 0x1EA4,   /* 0xC4, 0x84, 0x83, 0,    */    L"\x00C2\x0301",  L"\x00C1\x0302",  L"\x0041\x0302\x0301",  "\x41\xC1", "\x41\x5E\x27",   "\xC2\x27", } ,
   { 0x1EA5,   /* 0xCA, 0xA4, 0xC3, 0,    */    L"\x00E2\x0301",  L"\x00E1\x0302",  L"\x0061\x0302\x0301",  "\x61\xE1", "\x61\x5E\x27",   "\xE2\x27", } ,
   { 0x1EA6,   /* 0xC1, 0x85, 0x84, 0,    */    L"\x00C2\x0300",  L"\x00C0\x0302",  L"\x0041\x0302\x0300",  "\x41\xC0", "\x41\x5E\x60",   "\xC2\x60", } ,
   { 0x1EA7,   /* 0xC7, 0xA5, 0xC0, 0,    */    L"\x00E2\x0300",  L"\x00E0\x0302",  L"\x0061\x0302\x0300",  "\x61\xE0", "\x61\x5E\x60",   "\xE2\x60", } ,
   { 0x1EA8,   /* 0xC2, 0x86, 0x85, 0,    */    L"\x00C2\x0309",  L"\x1EA2\x0302",  L"\x0041\x0302\x0309",  "\x41\xC5", "\x41\x5E\x3F",   "\xC2\x3F", } ,
   { 0x1EA9,   /* 0xC8, 0xA6, 0xC4, 0,    */    L"\x00E2\x0309",  L"\x1EA3\x0302",  L"\x0061\x0302\x0309",  "\x61\xE5", "\x61\x5E\x3F",   "\xE2\x3F", } ,
   { 0x1EAA,   /* 0xC3, 0x06, 0x1C, 0,    */    L"\x00C2\x0303",  L"\x00C3\x0302",  L"\x0041\x0302\x0303",  "\x41\xC3", "\x41\x5E\x7E",   "\xC2\x7E", } ,
   { 0x1EAB,   /* 0xC9, 0xE7, 0xC5, 0,    */    L"\x00E2\x0303",  L"\x00E3\x0302",  L"\x0061\x0302\x0303",  "\x61\xE3", "\x61\x5E\x7E",   "\xE2\x7E", } ,
   { 0x1EAC,   /* 0x86, 0x87, 0x03, 0,    */    L"\x00C2\x0323",  L"\x1EA0\x0302",  L"\x0041\x0302\x0323",  "\x41\xC4", "\x41\x5E\x2E",   "\xC2\x2E", } ,
   { 0x1EAD,   /* 0xCB, 0xA7, 0xC6, 0,    */    L"\x00E2\x0323",  L"\x1EA1\x0302",  L"\x0061\x0302\x0323",  "\x61\xE4", "\x61\x5E\x2E",   "\xE2\x2E", } ,
   { 0x1EAE,   /* 0xC0, 0x81, 0x8D, 0,    */    L"\x0102\x0301",  L"\x00C1\x0306",  L"\x0041\x0306\x0301",  "\x41\xC9", "\x41\x28\x27",   "\xC5\x27", } ,
   { 0x1EAF,   /* 0xBE, 0xA1, 0xA1, 0,    */    L"\x0103\x0301",  L"\x00E1\x0306",  L"\x0061\x0306\x0301",  "\x61\xE9", "\x61\x28\x27",   "\xE5\x27", } ,
   { 0x1EB0,   /* 0xAF, 0x82, 0x8E, 0,    */    L"\x0102\x0300",  L"\x00C0\x0306",  L"\x0041\x0306\x0300",  "\x41\xC8", "\x41\x28\x60",   "\xC5\x60", } ,
   { 0x1EB1,   /* 0xBB, 0xA2, 0xA2, 0,    */    L"\x0103\x0300",  L"\x00E0\x0306",  L"\x0061\x0306\x0300",  "\x61\xE8", "\x61\x28\x60",   "\xE5\x60", } ,
   { 0x1EB2,   /* 0xBA, 0x02, 0x8F, 0,    */    L"\x0102\x0309",  L"\x1EA2\x0306",  L"\x0041\x0306\x0309",  "\x41\xDA", "\x41\x28\x3F",   "\xC5\x3F", } ,
   { 0x1EB3,   /* 0xBC, 0xC6, 0xA3, 0,    */    L"\x0103\x0309",  L"\x1EA3\x0306",  L"\x0061\x0306\x0309",  "\x61\xFA", "\x61\x28\x3F",   "\xE5\x3F", } ,
   { 0x1EB4,   /* 0xBF, 0x05, 0xF0, 0,    */    L"\x0102\x0303",  L"\x00C3\x0306",  L"\x0041\x0306\x0303",  "\x41\xDC", "\x41\x28\x7E",   "\xC5\x7E", } ,
   { 0x1EB5,   /* 0xBD, 0xC7, 0xA4, 0,    */    L"\x0103\x0303",  L"\x00E3\x0306",  L"\x0061\x0306\x0303",  "\x61\xFC", "\x61\x28\x7E",   "\xE5\x7E", } ,
   { 0x1EB6,   /* 0x85, 0x83, 0x04, 0,    */    L"\x0102\x0323",  L"\x1EA0\x0306",  L"\x0041\x0306\x0323",  "\x41\xCB", "\x41\x28\x2E",   "\xC5\x2E", } ,
   { 0x1EB7,   /* 0xC6, 0xA3, 0xA5, 0,    */    L"\x0103\x0323",  L"\x1EA1\x0306",  L"\x0061\x0306\x0323",  "\x61\xEB", "\x61\x28\x2E",   "\xE5\x2E", } ,
   { 0x1EB8,   /* 0x8B, 0x89, 0x05, 0,    */    L"\x0045\x0323",  NULL,             NULL,                   "\x45\xCF", "\x45\x2E",       NULL,       } ,
   { 0x1EB9,   /* 0xD1, 0xA9, 0xCB, 0,    */    L"\x0065\x0323",  NULL,             NULL,                   "\x65\xEF", "\x65\x2E",       NULL,       } ,
   { 0x1EBA,   /* 0x88, 0xCB, 0xDE, 0,    */    L"\x0045\x0309",  NULL,             NULL,                   "\x45\xDB", "\x45\x3F",       NULL,       } ,
   { 0x1EBB,   /* 0xCE, 0xEB, 0xC8, 0,    */    L"\x0065\x0309",  NULL,             NULL,                   "\x65\xFB", "\x65\x3F",       NULL,       } ,
   { 0x1EBC,   /* 0x89, 0x88, 0xFE, 0,    */    L"\x0045\x0303",  NULL,             NULL,                   "\x45\xD5", "\x45\x7E",       NULL,       } ,
   { 0x1EBD,   /* 0xCF, 0xA8, 0xEB, 0,    */    L"\x0065\x0303",  NULL,             NULL,                   "\x65\xF5", "\x65\x7E",       NULL,       } ,
   { 0x1EBE,   /* 0xDA, 0x8A, 0x90, 0,    */    L"\x00CA\x0301",  L"\x00C9\x0302",  L"\x0045\x0302\x0301",  "\x45\xC1", "\x45\x5E\x27",   "\xCA\x27", } ,
   { 0x1EBF,   /* 0xD5, 0xAA, 0x89, 0,    */    L"\x00EA\x0301",  L"\x00E9\x0302",  L"\x0065\x0302\x0301",  "\x65\xE1", "\x65\x5E\x27",   "\xEA\x27", } ,
   { 0x1EC0,   /* 0xC5, 0x8B, 0x93, 0,    */    L"\x00CA\x0300",  L"\x00C8\x0302",  L"\x0045\x0302\x0300",  "\x45\xC0", "\x45\x5E\x60",   "\xCA\x60", } ,
   { 0x1EC1,   /* 0xD2, 0xAB, 0x8A, 0,    */    L"\x00EA\x0300",  L"\x00E8\x0302",  L"\x0065\x0302\x0300",  "\x65\xE0", "\x65\x5E\x60",   "\xEA\x60", } ,
   { 0x1EC2,   /* 0xCD, 0x8C, 0x94, 0,    */    L"\x00CA\x0309",  L"\x1EBA\x0302",  L"\x0045\x0302\x0309",  "\x45\xC5", "\x45\x5E\x3F",   "\xCA\x3F", } ,
   { 0x1EC3,   /* 0xD3, 0xAC, 0x8B, 0,    */    L"\x00EA\x0309",  L"\x1EBB\x0302",  L"\x0065\x0302\x0309",  "\x65\xE5", "\x65\x5E\x3F",   "\xEA\x3F", } ,
   { 0x1EC4,   /* 0xD9, 0x8D, 0x95, 0,    */    L"\x00CA\x0303",  L"\x1EBC\x0302",  L"\x0045\x0302\x0303",  "\x45\xC3", "\x45\x5E\x7E",   "\xCA\x7E", } ,
   { 0x1EC5,   /* 0xD4, 0xAD, 0xCD, 0,    */    L"\x00EA\x0303",  L"\x1EBD\x0302",  L"\x0065\x0302\x0303",  "\x65\xE3", "\x65\x5E\x7E",   "\xEA\x7E", } ,
   { 0x1EC6,   /* 0x8C, 0x8E, 0x06, 0,    */    L"\x00CA\x0323",  L"\x1EB8\x0302",  L"\x0045\x0302\x0323",  "\x45\xC4", "\x45\x5E\x2E",   "\xCA\x2E", } ,
   { 0x1EC7,   /* 0xD6, 0xAE, 0x8C, 0,    */    L"\x00EA\x0323",  L"\x1EB9\x0302",  L"\x0065\x0302\x0323",  "\x65\xE4", "\x65\x5E\x2E",   "\xEA\x2E", } ,
   { 0x1EC8,   /* 0x8E, 0x9B, 0xB7, 0,    */    L"\x0049\x0309",  NULL,             NULL,                   NULL,       "\x49\x3F",       NULL,       } ,
   { 0x1EC9,   /* 0xD8, 0xEF, 0xCC, 0,    */    L"\x0069\x0309",  NULL,             NULL,                   NULL,       "\x69\x3F",       NULL,       } ,
   { 0x1ECA,   /* 0x91, 0x98, 0x10, 0,    */    L"\x0049\x0323",  NULL,             NULL,                   NULL,       "\x49\x2E",       NULL,       } ,
   { 0x1ECB,   /* 0xDE, 0xB8, 0xCE, 0,    */    L"\x0069\x0323",  NULL,             NULL,                   NULL,       "\x69\x2E",       NULL,       } ,
   { 0x1ECC,   /* 0x96, 0x9A, 0x11, 0,    */    L"\x004F\x0323",  NULL,             NULL,                   "\x4F\xCF", "\x4F\x2E",       NULL,       } ,
   { 0x1ECD,   /* 0xE4, 0xF7, 0x86, 0,    */    L"\x006F\x0323",  NULL,             NULL,                   "\x6F\xEF", "\x6F\x2E",       NULL,       } ,
   { 0x1ECE,   /* 0x93, 0x99, 0xBD, 0,    */    L"\x004F\x0309",  NULL,             NULL,                   "\x4F\xDB", "\x4F\x3F",       NULL,       } ,
   { 0x1ECF,   /* 0xE1, 0xF6, 0xD5, 0,    */    L"\x006F\x0309",  NULL,             NULL,                   "\x6F\xFB", "\x6F\x3F",       NULL,       } ,
   { 0x1ED0,   /* 0xFF, 0x8F, 0x96, 0,    */    L"\x00D4\x0301",  L"\x00D3\x0302",  L"\x004F\x0302\x0301",  "\x4F\xC1", "\x4F\x5E\x27",   "\xD4\x27", } ,
   { 0x1ED1,   /* 0xE8, 0xAF, 0xD3, 0,    */    L"\x00F4\x0301",  L"\x00F3\x0302",  L"\x006F\x0302\x0301",  "\x6F\xE1", "\x6F\x5E\x27",   "\xF4\x27", } ,
   { 0x1ED2,   /* 0xDB, 0x90, 0x97, 0,    */    L"\x00D4\x0300",  L"\x00D2\x0302",  L"\x004F\x0302\x0300",  "\x4F\xC0", "\x4F\x5E\x60",   "\xD4\x60", } ,
   { 0x1ED3,   /* 0xE5, 0xB0, 0xD2, 0,    */    L"\x00F4\x0300",  L"\x00F2\x0302",  L"\x006F\x0302\x0300",  "\x6F\xE0", "\x6F\x5E\x60",   "\xF4\x60", } ,
   { 0x1ED4,   /* 0xE0, 0x91, 0x98, 0,    */    L"\x00D4\x0309",  L"\x1ECE\x0302",  L"\x004F\x0302\x0309",  "\x4F\xC5", "\x4F\x5E\x3F",   "\xD4\x3F", } ,
   { 0x1ED5,   /* 0xE6, 0xB1, 0xB0, 0,    */    L"\x00F4\x0309",  L"\x1ECF\x0302",  L"\x006F\x0302\x0309",  "\x6F\xE5", "\x6F\x5E\x3F",   "\xF4\x3F", } ,
   { 0x1ED6,   /* 0xF0, 0x92, 0x99, 0,    */    L"\x00D4\x0303",  L"\x00D5\x0302",  L"\x004F\x0302\x0303",  "\x4F\xC3", "\x4F\x5E\x7E",   "\xD4\x7E", } ,
   { 0x1ED7,   /* 0xE7, 0xB2, 0x87, 0,    */    L"\x00F4\x0303",  L"\x00F5\x0302",  L"\x006F\x0302\x0303",  "\x6F\xE3", "\x6F\x5E\x7E",   "\xF4\x7E", } ,
   { 0x1ED8,   /* 0x97, 0x93, 0x12, 0,    */    L"\x00D4\x0323",  L"\x1ECC\x0302",  L"\x004F\x0302\x0323",  "\x4F\xC4", "\x4F\x5E\x2E",   "\xD4\x2E", } ,
   { 0x1ED9,   /* 0xE9, 0xB5, 0xB6, 0,    */    L"\x00F4\x0323",  L"\x1ECD\x0302",  L"\x006F\x0302\x0323",  "\x6F\xE4", "\x6F\x5E\x2E",   "\xF4\x2E", } ,
   { 0x1EDA,   /* 0x9B, 0x95, 0x9D, 0,    */    L"\x01A0\x0301",  L"\x00D3\x031B",  L"\x004F\x031B\x0301",  "\xD4\xD9", "\x4F\x2B\x27",   "\xB4\x27", } ,
   { 0x1EDB,   /* 0xED, 0xBE, 0xA7, 0,    */    L"\x01A1\x0301",  L"\x00F3\x031B",  L"\x006F\x031B\x0301",  "\xF4\xF9", "\x6F\x2B\x27",   "\xBD\x27", } ,
   { 0x1EDC,   /* 0x98, 0x96, 0x9E, 0,    */    L"\x01A0\x0300",  L"\x00D2\x031B",  L"\x004F\x031B\x0300",  "\xD4\xD8", "\x4F\x2B\x60",   "\xB4\x60", } ,
   { 0x1EDD,   /* 0xEA, 0xB6, 0xA9, 0,    */    L"\x01A1\x0300",  L"\x00F2\x031B",  L"\x006F\x031B\x0300",  "\xF4\xF8", "\x6F\x2B\x60",   "\xBD\x60", } ,
   { 0x1EDE,   /* 0x99, 0x97, 0x9F, 0,    */    L"\x01A0\x0309",  L"\x1ECE\x031B",  L"\x004F\x031B\x0309",  "\xD4\xDB", "\x4F\x2B\x3F",   "\xB4\x3F", } ,
   { 0x1EDF,   /* 0xEB, 0xB7, 0xAA, 0,    */    L"\x01A1\x0309",  L"\x1ECF\x031B",  L"\x006F\x031B\x0309",  "\xF4\xFB", "\x6F\x2B\x3F",   "\xBD\x3F", } ,
   { 0x1EE0,   /* 0x9A, 0xB3, 0xA6, 0,    */    L"\x01A0\x0303",  L"\x00D5\x031B",  L"\x004F\x031B\x0303",  "\xD4\xD5", "\x4F\x2B\x7E",   "\xB4\x7E", } ,
   { 0x1EE1,   /* 0xEC, 0xDE, 0xAB, 0,    */    L"\x01A1\x0303",  L"\x00F5\x031B",  L"\x006F\x031B\x0303",  "\xF4\xF5", "\x6F\x2B\x7E",   "\xBD\x7E", } ,
   { 0x1EE2,   /* 0x9C, 0x94, 0x13, 0,    */    L"\x01A0\x0323",  L"\x1ECC\x031B",  L"\x004F\x031B\x0323",  "\xD4\xCF", "\x4F\x2B\x2E",   "\xB4\x2E", } ,
   { 0x1EE3,   /* 0xEE, 0xFE, 0xAE, 0,    */    L"\x01A1\x0323",  L"\x1ECD\x031B",  L"\x006F\x031B\x0323",  "\xF4\xEF", "\x6F\x2B\x2E",   "\xBD\x2E", } ,
   { 0x1EE4,   /* 0x02, 0x9E, 0x14, 0,    */    L"\x0055\x0323",  NULL,             NULL,                   "\x55\xCF", "\x55\x2E",       NULL,       } ,
   { 0x1EE5,   /* 0xF4, 0xF8, 0xF8, 0,    */    L"\x0075\x0323",  NULL,             NULL,                   "\x75\xEF", "\x75\x2E",       NULL,       } ,
   { 0x1EE6,   /* 0x9E, 0x9C, 0xD1, 0,    */    L"\x0055\x0309",  NULL,             NULL,                   "\x55\xDB", "\x55\x3F",       NULL,       } ,
   { 0x1EE7,   /* 0xF1, 0xFC, 0xFB, 0,    */    L"\x0075\x0309",  NULL,             NULL,                   "\x75\xFB", "\x75\x3F",       NULL,       } ,
   { 0x1EE8,   /* 0x11, 0xBA, 0xAD, 0,    */    L"\x01AF\x0301",  L"\x00DA\x031B",  L"\x0055\x031B\x0301",  "\xD6\xD9", "\x55\x2B\x27",   "\xBF\x27", } ,
   { 0x1EE9,   /* 0xF8, 0xD1, 0xD9, 0,    */    L"\x01B0\x0301",  L"\x00FA\x031B",  L"\x0075\x031B\x0301",  "\xF6\xF9", "\x75\x2B\x27",   "\xDF\x27", } ,
   { 0x1EEA,   /* 0x04, 0xBB, 0xAF, 0,    */    L"\x01AF\x0300",  L"\x00D9\x031B",  L"\x0055\x031B\x0300",  "\xD6\xD8", "\x55\x2B\x60",   "\xBF\x60", } ,
   { 0x1EEB,   /* 0xF5, 0xD7, 0xD8, 0,    */    L"\x01B0\x0300",  L"\x00F9\x031B",  L"\x0075\x031B\x0300",  "\xF6\xF8", "\x75\x2B\x60",   "\xDF\x60", } ,
   { 0x1EEC,   /* 0x05, 0xBC, 0xB1, 0,    */    L"\x01AF\x0309",  L"\x1EE6\x031B",  L"\x0055\x031B\x0309",  "\xD6\xDB", "\x55\x2B\x3F",   "\xBF\x3F", } ,
   { 0x1EED,   /* 0xF6, 0xD8, 0xBA, 0,    */    L"\x01B0\x0309",  L"\x1EE7\x031B",  L"\x0075\x031B\x0309",  "\xF6\xFB", "\x75\x2B\x3F",   "\xDF\x3F", } ,
   { 0x1EEE,   /* 0x06, 0xFF, 0x1D, 0,    */    L"\x01AF\x0303",  L"\x0168\x031B",  L"\x0055\x031B\x0303",  "\xD6\xD5", "\x55\x2B\x7E",   "\xBF\x7E", } ,
   { 0x1EEF,   /* 0xF7, 0xE6, 0xBB, 0,    */    L"\x01B0\x0303",  L"\x0169\x031B",  L"\x0075\x031B\x0303",  "\xF6\xF5", "\x75\x2B\x7E",   "\xDF\x7E", } ,
   { 0x1EF0,   /* 0x12, 0xB9, 0x15, 0,    */    L"\x01AF\x0323",  L"\x1EE4\x031B",  L"\x0055\x031B\x0323",  "\xD6\xCF", "\x55\x2B\x2E",   "\xBF\x2E", } ,
   { 0x1EF1,   /* 0xF9, 0xF1, 0xBF, 0,    */    L"\x01B0\x0323",  L"\x1EE5\x031B",  L"\x0075\x031B\x0323",  "\xF6\xEF", "\x75\x2B\x2E",   "\xDF\x2E", } ,
   { 0x1EF2,   /* 0x13, 0x9F, 0xB2, 0,    */    L"\x0059\x0300",  NULL,             NULL,                   "\x59\xD8", "\x59\x60",       NULL,       } ,
   { 0x1EF3,   /* 0xFA, 0xCF, 0xFF, 0,    */    L"\x0079\x0300",  NULL,             NULL,                   "\x79\xF8", "\x79\x60",       NULL,       } ,
   { 0x1EF4,   /* 0x17, 0x1E, 0x19, 0,    */    L"\x0059\x0323",  NULL,             NULL,                   NULL,       "\x59\x2E",       NULL,       } ,
   { 0x1EF5,   /* 0xFE, 0xDC, 0x9C, 0,    */    L"\x0079\x0323",  NULL,             NULL,                   NULL,       "\x79\x2E",       NULL,       } ,
   { 0x1EF6,   /* 0x14, 0x14, 0xFD, 0,    */    L"\x0059\x0309",  NULL,             NULL,                   "\x59\xDB", "\x59\x3F",       NULL,       } ,
   { 0x1EF7,   /* 0xFB, 0xD6, 0x9B, 0,    */    L"\x0079\x0309",  NULL,             NULL,                   "\x79\xFB", "\x79\x3F",       NULL,       } ,
   { 0x1EF8,   /* 0x15, 0x19, 0xB3, 0,    */    L"\x0059\x0303",  NULL,             NULL,                   "\x59\xD5", "\x59\x7E",       NULL,       } ,
   { 0x1EF9,   /* 0xFC, 0xDB, 0xCF, 0,    */    L"\x0079\x0303",  NULL,             NULL,                   "\x79\xF5", "\x79\x7E",       NULL,       } ,
} ;

static const int VIET_EQUIVALENT_TABLE_NELEM = NELEMOF ( VietEquivalentTable ) ;



static const wchar_t *const VniToUnicode_C0_FF [] = {
   L"\x0302\x0300",
   L"\x0302\x0301",
   NULL,
   L"\x0302\x0303",
   L"\x0302\x0323",
   L"\x0302\x0309",
   NULL,
   NULL,
   L"\x0306\x0300",
   L"\x0306\x0301",
   NULL,
   L"\x0306\x0323",
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   L"\x0306\x0309",
   NULL,
   L"\x0306\x0303",
   NULL,
   NULL,
   NULL,
   L"\x0302\x0300",
   L"\x0302\x0301",
   NULL,
   L"\x0302\x0303",
   L"\x0302\x0323",
   L"\x0302\x0309",
   NULL,
   NULL,
   L"\x0306\x0300",
   L"\x0306\x0301",
   NULL,
   L"\x0306\x0323",
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   NULL,
   L"\x0306\x0309",
   NULL,
   L"\x0306\x0303",
   NULL,
   NULL,
   NULL,
} ;



static const wchar_t ViqrDiacritics [] = L"\x0027\x0028\x002B\x002E\x003F\x005E\x0060\x007E\x005C" ;



static const wchar_t NoTcvn2CharLatin [] = L"\x00DA\x00DD" ;
static const wchar_t NoTcvn2CharLatinEx [] = L"\x1EE4\x1EE8\x1EEA\x1EEC\x1EEE\x1EF0\x1EF2\x1EF4\x1EF6\x1EF8" ;



static const wchar_t NoTcvn3CharLatin [] = L"\x00C0\x00C1\x00C3\x00C8\x00C9\x00CC\x00CD\x00D2\x00D3\x00D5\x00D9\x00DA\x00DD\x0128\x0168" ;
static const wchar_t NoTcvn3CharLatinEx [] = L"\x1EA0\x1EA2\x1EA4\x1EA6\x1EA8\x1EAA\x1EAC\x1EAE\x1EB0\x1EB2\x1EB4\x1EB6\x1EB8\x1EBA\x1EBC\x1EBE\x1EC0\x1EC2\x1EC4\x1EC6\x1EC8\x1ECA\x1ECC\x1ECE\x1ED0\x1ED2\x1ED4\x1ED6\x1ED8\x1EDA\x1EDC\x1EDE\x1EE0\x1EE2\x1EE4\x1EE6\x1EE8\x1EEA\x1EEC\x1EEE\x1EF0\x1EF2\x1EF4\x1EF6\x1EF8" ;



#if defined _MSC_VER && _MSC_VER < 1300   // Cannot compile wide char 0x0080-0x00FF with VC6
#include "msc.h"
#endif



#endif
