// brsfile.h

#ifndef BRSFILE_H
#define BRSFILE_H

#ifdef __cplusplus
extern "C" {
#endif


int WINAPI BrowseForFileA ( HWND hWnd, char *szSelectedFile, int nMaxLen, const char *szInitialDir, const char *szTitle, const char *szFilter, int IsAllowMultiSelect ) ;
int WINAPI BrowseForFileW ( HWND hWnd, wchar_t *szSelectedFile, int nMaxLen, const wchar_t *szInitialDir, const wchar_t *szTitle, const wchar_t *szFilter, int IsAllowMultiSelect ) ;


#ifdef UNICODE
#define BrowseForFile BrowseForFileW
#else
#define BrowseForFile BrowseForFileA
#endif


#ifdef __cplusplus
}
#endif

#endif


