// uni2cs.h

#ifndef UNI2CS_H
#define UNI2CS_H


unsigned long GetUnicodeCharsetBit ( int cUnicode ) ;


#define UNICS_EUROPEAN                 0x1
#define UNICS_CENTRAL                  0x2
#define UNICS_TURKISH                  0x4
#define UNICS_BALTIC                   0x8
#define UNICS_CYRILLIC                 0x10
#define UNICS_GREEK                    0x20
#define UNICS_SJIS                     0x100
#define UNICS_KS                       0x200
#define UNICS_GB                       0x400
#define UNICS_BIG5                     0x800
#define UNICS_EUROPEAN_VISTA           0x1000
#define UNICS_CYRILLIC_VISTA           0x2000
#define UNICS_GREEK_VISTA              0x4000


int UnicodeBlockToCharset ( int nIndex ) ;


#define UNICS_CJK_CHARSET              0x1
#define UNICS_CHINESE_CHARSET          0x2
#define UNICS_CHARSET_UNDEFINED        0xFF


#endif
