// sbctbl.h

#ifndef SBCTBL_H
#define SBCTBL_H


#ifdef __cplusplus
extern "C" {
#endif



#ifdef SBCTBL_DLL


int WINAPI SingleByteToUnicode ( int C, int nCodePage ) ;
int WINAPI UnicodeToSingleByte ( int cUnicode, int nCodePage ) ;
int WINAPI IsSbcValidCodePage ( int nCodePage ) ;
int WINAPI GetDllVersion ( void ) ;


#else


typedef int ( WINAPI *SINGLEBYTETOUNICODE ) ( int C, int nCodePage ) ;
typedef int ( WINAPI *UNICODETOSINGLEBYTE ) ( int cUnicode, int nCodePage ) ;
typedef int ( WINAPI *ISSBCVALIDCODEPAGE ) ( int nCodePage ) ;


#endif // else of #ifdef SBCTBL_DLL



#ifdef __cplusplus
}
#endif

#endif


