// conv_opt_old_r.cpp

#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "msc.h"
#include "rtfconv.h"
#include "rtfconv_opt.h"

#ifndef CONV_OPT_OLD_DECLARE
#define CONV_OPT_OLD_DECLARE(type,name)   type name = (type) 0
#endif
#include "conv_opt_old_r.h"


static int dummy ;



static const OPTION_INTEGER OptionIntegerListOld [] = {
   { & nSavedType,      "FileType" },
   { & nSavedType,      "SavedType" },
   { & nSavedSrcCode,   "SavedSrcCode" },
   { & nSavedDstCode,   "SavedDstCode" },
   { & nSavedWindowX,   "SavedWindowX" },
   { & nSavedWindowY,   "SavedWindowY" },
   { & IsOutputNumberHtml, "IsOutputNumberHtml" },
   { & IsOutputNumber, "IsOutputNumber" },
   { & nOutputNumberStyle, "OutputNumberStyle" },
   { & nInvalidCharFormat, "InvalidCharFormat" },
   { & IsConvertPua, "IsConvertDbcsPua" },
   { & IsJisNoVendor, "IsJisNoVendor" },
   { & nDefaultCjkCodePage, "UniCodePage" },
} ;


static const OPTION_STRING_A OptionStringListOldA [] = {
   { szEuropeanFont,             "SavedAsciiFont",    FONTNAME_MAX },
   { szJapaneseFont,             "SavedJapaneseFont", FONTNAME_MAX },
   { szKoreanFont,               "SavedKoreanFont",   FONTNAME_MAX },
   { szChineseSimplifiedFont,    "SavedGbFont",       FONTNAME_MAX },
   { szChineseTraditionalFont,   "SavedBig5Font",     FONTNAME_MAX },
   { szThaiFont,                 "SavedThaiFont",     FONTNAME_MAX },
   { szBrowsePathA,              "SavedPath",         MAX_PATH },
   { szBrowsePathA,              "BrowsePath",        MAX_PATH },
   { szEuropeanFont,             "AsciiFont",         FONTNAME_MAX },
   { szChineseSimplifiedFont,    "GbFont",            FONTNAME_MAX },
   { szChineseTraditionalFont,   "Big5Font",          FONTNAME_MAX },
} ;


static const OPTION_STRING_W OptionStringListOldW [] = {
   { szBrowsePathW,  "SavedPathW",     MAX_PATH },
} ;


static const OPTION_BINARY OptionBinaryListOld [] = {
   { (unsigned short*) & dummy, "dummy", sizeof(dummy)/sizeof(short) },
} ;



#define ReadOptionA ReadOldOptionA
#define ReadOptionW ReadOldOptionW
#define FreeFontNameArray FreeFontNameArrayOld

#define OptionIntegerList     OptionIntegerListOld
#define OptionStringListA     OptionStringListOldA
#define OptionStringListW     OptionStringListOldW
#ifdef SETUP_R_EXE
#define OptionBinaryList      OptionBinaryListOld
#endif

#define OPTION_INTEGER_LIST_NELEM      (sizeof(OptionIntegerListOld)/sizeof(OPTION_INTEGER))
#define OPTION_STRING_LIST_A_NELEM     (sizeof(OptionStringListOldA)/sizeof(OPTION_STRING_A))
#define OPTION_STRING_LIST_W_NELEM     (sizeof(OptionStringListOldW)/sizeof(OPTION_STRING_W))
#ifdef SETUP_R_EXE
#define OPTION_BINARY_LIST_NELEM       (sizeof(OptionBinaryListOld)/sizeof(OPTION_BINARY))
#endif



#define CONV_OPT_OLD

#include "conv_opt.cpp"



