// conv_reg.h


// for SETUP.EXE and LOADCMD.EXE



#define REG_SUBKEY_RTFCONV_A    "SOFTWARE\\Harigaya\\Rtfconv"
#define REG_SUBKEY_RTFCONV_W   L"SOFTWARE\\Harigaya\\Rtfconv"

#define REG_SUBKEY_CHNCONV_A    "SOFTWARE\\Harigaya\\Chnconv"
#define REG_SUBKEY_CHNCONV_W   L"SOFTWARE\\Harigaya\\Chnconv"


#define REG_SUBKEY_RTFCONV_UNINSTALL_A   "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Harigaya Rtfconv"
#define REG_SUBKEY_RTFCONV_UNINSTALL_W  L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Harigaya Rtfconv"

#define REG_SUBKEY_CHNCONV_UNINSTALL_A   "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Harigaya Chnconv"
#define REG_SUBKEY_CHNCONV_UNINSTALL_W  L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Harigaya Chnconv"


#define HOMEPAGE_ADDRESS_A     "http://www5b.biglobe.ne.jp/~harigaya/"
#define HOMEPAGE_ADDRESS_W    L"http://www5b.biglobe.ne.jp/~harigaya/"



#if defined SETUP_R
#define REG_SUBKEY_A             REG_SUBKEY_RTFCONV_A
#define REG_SUBKEY_W             REG_SUBKEY_RTFCONV_W
#define REG_SUBKEY_UNINSTALL_A   REG_SUBKEY_RTFCONV_UNINSTALL_A
#define REG_SUBKEY_UNINSTALL_W   REG_SUBKEY_RTFCONV_UNINSTALL_W
#endif

#if defined SETUP_C
#define REG_SUBKEY_A             REG_SUBKEY_CHNCONV_A
#define REG_SUBKEY_W             REG_SUBKEY_CHNCONV_W
#define REG_SUBKEY_UNINSTALL_A   REG_SUBKEY_CHNCONV_UNINSTALL_A
#define REG_SUBKEY_UNINSTALL_W   REG_SUBKEY_CHNCONV_UNINSTALL_W
#endif



#if defined SETUP_R
#define FOLDER_NAME_A       "Rtfconv"
#define FOLDER_NAME_W      L"Rtfconv"
#endif

#if defined SETUP_C
#define FOLDER_NAME_A       "Chnconv"
#define FOLDER_NAME_W      L"Chnconv"
#endif



#if defined SETUP_R || defined SETUP_C
#define BATCH_FILE_NAME_J_A       "setcmd-j.bat"
#define BATCH_FILE_NAME_J_W      L"setcmd-j.bat"
#define BATCH_FILE_NAME_E_A       "setcmd-e.bat"
#define BATCH_FILE_NAME_E_W      L"setcmd-e.bat"
#endif



#if defined LOADCMD_R
#define REG_SUBKEY_A             REG_SUBKEY_RTFCONV_A
#define REG_SUBKEY_W             REG_SUBKEY_RTFCONV_W
#define REG_SUBKEY_SUB_A         REG_SUBKEY_CHNCONV_A
#define REG_SUBKEY_SUB_W         REG_SUBKEY_CHNCONV_W
#endif



#if defined LOADCMD_C
#define REG_SUBKEY_A             REG_SUBKEY_CHNCONV_A
#define REG_SUBKEY_W             REG_SUBKEY_CHNCONV_W
#define REG_SUBKEY_SUB_A         REG_SUBKEY_RTFCONV_A
#define REG_SUBKEY_SUB_W         REG_SUBKEY_RTFCONV_W
#endif



