// reg.cpp

#include <windows.h>
#include "msc.h"
#include "reg.h"



// szValueName  "" w肵A"()" ̒l擾/o



static unsigned long TranslateMode ( unsigned long dwMode ) ;

#define RegDeleteKeyExA    RegDeleteKeyExA_
#define RegDeleteKeyExW    RegDeleteKeyExW_
static LONG RegDeleteKeyExA ( HKEY hKey, LPCSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) ;
static LONG RegDeleteKeyExW ( HKEY hKey, LPCWSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) ;



//////////////////////////////
//          ANSI          //
//////////////////////////////



// WXg牿擾iANSIŁj
// dwDataSizeMax ̓oCg
// dwDataTypeRequired ȍ~ 0 w肵Al݂邩mFďI
//  0 As 0 ȊOԂ
int GetRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwDataTypeRequired, void *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwDataType = dwDataTypeRequired ;

   nResult = RegOpenKeyExA ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegQueryValueExA ( hRegKey, szValueName, NULL, & dwDataType, (unsigned char*) pData, & dwDataSizeMax ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   if ( dwDataTypeRequired && dwDataType != dwDataTypeRequired ) return 1 ;
   return 0 ;
}



// WXg։o͂iANSIŁj
// dwDataSize ̓oCg
//  0 As 0 ȊOԂ
int SetRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwDataType, const void *pData, unsigned long dwDataSize, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegCreateKeyExA ( hKey, szSubkey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE | TranslateMode ( dwMode ), NULL, & hRegKey, NULL ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegSetValueExA ( hRegKey, szValueName, 0, dwDataType, (const unsigned char*) pData, dwDataSize ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// WXg當擾iANSIŁj
// dwDataSizeMax ͕
//  0 As 0 ȊOԂ
int GetRegStringA ( HKEY hKey, const char *szSubkey, const char *szValueName, char *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) {
   return GetRegInfoA ( hKey, szSubkey, szValueName, REG_SZ, pData, dwDataSizeMax * sizeof(char), dwMode ) ;
}



// WXg֕o͂iANSIŁj
//  0 As 0 ȊOԂ
int SetRegStringA ( HKEY hKey, const char *szSubkey, const char *szValueName, const char *pData, unsigned long dwMode ) {
   return SetRegInfoA ( hKey, szSubkey, szValueName, REG_SZ, pData, (unsigned long) ( strlen ( pData ) + 1 ) * sizeof(char), dwMode ) ;
}



// WXg̃Gg[폜iANSIŁj
// szValueName  NULL Ȃ L[̂̂폜
// ATuL[݂L[폜łȂ
//  0 As 0 ȊOԂ
int DeleteRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegOpenKeyExA ( hKey, szSubkey, 0, KEY_WRITE | KEY_QUERY_VALUE | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   if ( szValueName ) nResult = RegDeleteValueA ( hRegKey, szValueName ) ;
   else {
      if ( TranslateMode ( dwMode ) ) nResult = RegDeleteKeyExA ( hKey, szSubkey, TranslateMode ( dwMode ), 0 ) ;
      else {
         if ( IsNT () ) nResult = RegDeleteKeyA ( hKey, szSubkey ) ;
         else {
            // 95nł́ATuL[݂Ă폜Ă܂̂ŁAOɌ
            unsigned long dwSubkeyCount ;
            nResult = RegQueryInfoKey ( hRegKey, NULL, NULL, NULL, & dwSubkeyCount, NULL, NULL, NULL, NULL, NULL, NULL, NULL) ;
            if ( nResult == ERROR_SUCCESS && ! dwSubkeyCount ) nResult = RegDeleteKeyA ( hKey, szSubkey ) ;
            else                                               nResult = ERROR_ACCESS_DENIED ;
         }
      }
   }

   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// WXgɃANZX\擾iANSIŁj
// dwAccessMask ɂ KEY_ALL_ACCESS, KEY_WRITE, KEY_READ w
// ANZX\Ȃ 0 ȊOAs\Ȃ 0 Ԃ
int IsRegKeyAccessibleA ( HKEY hKey, const char *szSubkey, REGSAM dwAccessMask, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegOpenKeyExA ( hKey, szSubkey, 0, dwAccessMask | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 0 ;
   RegCloseKey ( hRegKey ) ;

   return 1 ;
}



// TuL[񋓂iANSIŁj
// nNumber ɂ 0 珇ɔԍw
//  0 As 0 ȊOԂ
int EnumRegSubkeyA ( HKEY hKey, const char *szSubkey, int nNumber, char *szName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwLength = MAX_PATH ;

   nResult = RegOpenKeyExA ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegEnumKeyExA ( hRegKey, nNumber, szName, & dwLength, NULL, NULL, NULL, NULL ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// Gg[񋓂iANSIŁj
// nNumber ɂ 0 珇ɔԍw
//  0 As 0 ȊOԂ
int EnumRegValueA ( HKEY hKey, const char *szSubkey, int nNumber, char *szName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwLength = MAX_PATH ;

   nResult = RegOpenKeyExA ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegEnumValueA ( hRegKey, nNumber, szName, & dwLength, NULL, NULL, NULL, NULL ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// WXg牿擾iUNICODEŁj
// dwDataSizeMax ̓oCg
// dwDataTypeRequired ȍ~ 0 w肵Al݂邩mFďI
//  0 As 0 ȊOԂ
int GetRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwDataTypeRequired, void *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwDataType = dwDataTypeRequired ;

   nResult = RegOpenKeyExW ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegQueryValueExW ( hRegKey, szValueName, NULL, & dwDataType, (unsigned char*) pData, & dwDataSizeMax ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   if ( dwDataTypeRequired && dwDataType != dwDataTypeRequired ) return 1 ;
   return 0 ;
}



// WXg։o͂iUNICODEŁj
// dwDataSize ̓oCg
//  0 As 0 ȊOԂ
int SetRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwDataType, const void *pData, unsigned long dwDataSize, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegCreateKeyExW ( hKey, szSubkey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE | TranslateMode ( dwMode ), NULL, & hRegKey, NULL ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegSetValueExW ( hRegKey, szValueName, 0, dwDataType, (const unsigned char*) pData, dwDataSize ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// WXg當擾iUNICODEŁj
// dwDataSizeMax ͕
//  0 As 0 ȊOԂ
int GetRegStringW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, wchar_t *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) {
   return GetRegInfoW ( hKey, szSubkey, szValueName, REG_SZ, pData, dwDataSizeMax * sizeof(wchar_t), dwMode ) ;
}



// WXg֕o͂iUNICODEŁj
//  0 As 0 ȊOԂ
int SetRegStringW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, const wchar_t *pData, unsigned long dwMode ) {
   return SetRegInfoW ( hKey, szSubkey, szValueName, REG_SZ, pData, (unsigned long) ( wcslen ( pData ) + 1 ) * sizeof(wchar_t), dwMode ) ;
}



// WXg̃Gg[폜iUNICODEŁj
// szValueName  NULL Ȃ L[̂̂폜
// ATuL[݂L[폜łȂ
//  0 As 0 ȊOԂ
int DeleteRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegOpenKeyExW ( hKey, szSubkey, 0, KEY_WRITE | KEY_QUERY_VALUE | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   if ( szValueName ) nResult = RegDeleteValueW ( hRegKey, szValueName ) ;
   else {
      if ( TranslateMode ( dwMode ) ) nResult = RegDeleteKeyExW ( hKey, szSubkey, TranslateMode ( dwMode ), 0 ) ;
      else {
         if ( IsNT () ) nResult = RegDeleteKeyW ( hKey, szSubkey ) ;
         else {
            // 95nł́ATuL[݂Ă폜Ă܂̂ŁAOɌ
            unsigned long dwSubkeyCount ;
            nResult = RegQueryInfoKey ( hRegKey, NULL, NULL, NULL, & dwSubkeyCount, NULL, NULL, NULL, NULL, NULL, NULL, NULL) ;
            if ( nResult == ERROR_SUCCESS && ! dwSubkeyCount ) nResult = RegDeleteKeyW ( hKey, szSubkey ) ;
            else                                               nResult = ERROR_ACCESS_DENIED ;
         }
      }
   }

   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// WXgɃANZX\擾iUNICODEŁj
// dwAccessMask ɂ KEY_ALL_ACCESS, KEY_WRITE, KEY_READ w
// ANZX\Ȃ 0 ȊOAs\Ȃ 0 Ԃ
int IsRegKeyAccessibleW ( HKEY hKey, const wchar_t *szSubkey, REGSAM dwAccessMask, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;

   nResult = RegOpenKeyExW ( hKey, szSubkey, 0, dwAccessMask | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 0 ;
   RegCloseKey ( hRegKey ) ;

   return 1 ;
}



// TuL[񋓁iUNICODEŁj
// nNumber ɂ 0 珇ɔԍw
//  0 As 0 ȊOԂ
int EnumRegSubkeyW ( HKEY hKey, const wchar_t *szSubkey, int nNumber, wchar_t *szName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwLength = MAX_PATH ;

   nResult = RegOpenKeyExW ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegEnumKeyExW ( hRegKey, nNumber, szName, & dwLength, NULL, NULL, NULL, NULL ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



// Gg[񋓂iUNICODEŁj
// nNumber ɂ 0 珇ɔԍw
//  0 As 0 ȊOԂ
int EnumRegValueW ( HKEY hKey, const wchar_t *szSubkey, int nNumber, wchar_t *szName, unsigned long dwMode ) {

   int nResult ;
   HKEY hRegKey ;
   unsigned long dwLength = MAX_PATH ;

   nResult = RegOpenKeyExW ( hKey, szSubkey, 0, KEY_READ | TranslateMode ( dwMode ), & hRegKey ) ;
   if ( nResult != ERROR_SUCCESS ) return 1 ;

   nResult = RegEnumValueW ( hRegKey, nNumber, szName, & dwLength, NULL, NULL, NULL, NULL ) ;
   RegCloseKey ( hRegKey ) ;

   if ( nResult != ERROR_SUCCESS ) return 1 ;
   return 0 ;
}



//////////////////////////////
//         ʊ֐         //
//////////////////////////////



#ifndef KEY_WOW64_64KEY
#define KEY_WOW64_64KEY    0x0100
#endif
#ifndef KEY_WOW64_32KEY
#define KEY_WOW64_32KEY    0x0200
#endif



static unsigned long TranslateMode ( unsigned long dwMode ) {

   unsigned long dwAccessMask = 0 ;

   if ( ( dwMode & REG_MODE_ALWAYS_32 ) &&   IS_WIN64 && IsWin64 () ) dwAccessMask |= KEY_WOW64_32KEY ;
   if ( ( dwMode & REG_MODE_ALWAYS_64 ) && ! IS_WIN64 && IsWin64 () ) dwAccessMask |= KEY_WOW64_64KEY ;

   return dwAccessMask ;
}



typedef LONG ( WINAPI *REGDELETEKEYEXA ) ( HKEY hKey, LPCSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) ;
typedef LONG ( WINAPI *REGDELETEKEYEXW ) ( HKEY hKey, LPCWSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) ;
static HINSTANCE hAdvapi32 ;
static int FreeLibraryOnDetach ( void ) ;



static LONG RegDeleteKeyExA ( HKEY hKey, LPCSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) {
#undef RegDeleteKeyExA

   static REGDELETEKEYEXA RegDeleteKeyExA ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hAdvapi32 && ( hAdvapi32 = LoadLibraryA ( "ADVAPI32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hAdvapi32, REGDELETEKEYEXA, RegDeleteKeyExA ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! RegDeleteKeyExA ) return ERROR_CALL_NOT_IMPLEMENTED ;

   return RegDeleteKeyExA ( hKey, lpSubKey, samDesired, Reserved ) ;
}



static LONG RegDeleteKeyExW ( HKEY hKey, LPCWSTR lpSubKey, REGSAM samDesired, DWORD Reserved ) {
#undef RegDeleteKeyExW

   static REGDELETEKEYEXW RegDeleteKeyExW ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hAdvapi32 && ( hAdvapi32 = LoadLibraryW ( L"ADVAPI32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hAdvapi32, REGDELETEKEYEXW, RegDeleteKeyExW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! RegDeleteKeyExW ) return ERROR_CALL_NOT_IMPLEMENTED ;

   return RegDeleteKeyExW ( hKey, lpSubKey, samDesired, Reserved ) ;
}



static void __cdecl ExitProc ( void ) {
   if ( hAdvapi32 ) FreeLibrary ( hAdvapi32 ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



