// sjismac.h

#ifndef SJISMAC_H
#define SJISMAC_H



///////////////////////////////////////////////////////////////////////////////////////
//                          Macintosh Shift-JIS --> UNICODE
///////////////////////////////////////////////////////////////////////////////////////


#define  Sjis2uniTable_Mac_80  NULL

static const unsigned short Sjis2uniTable_Mac_81 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x814x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x815x
      0,       0,       0,       0,       0x2014,  0,       0,       0,       
      0x301C,  0x2016,  0,       0,       0,       0,       0,       0,       // 0x816x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x817x
      0,       0,       0,       0,       0x2212,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x818x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x00A2,  0x00A3,  0,       0,       0,       0,       0,       // 0x819x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Cx
      0,       0,       0x00AC,  0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x81Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Sjis2uniTable_Mac_82  NULL
#define  Sjis2uniTable_Mac_83  NULL
#define  Sjis2uniTable_Mac_84  NULL

static const unsigned short Sjis2uniTable_Mac_85 [] = {
      0x2460,  0x2461,  0x2462,  0x2463,  0x2464,  0x2465,  0x2466,  0x2467,  // 0x854x
      0x2468,  0x2469,  0x246A,  0x246B,  0x246C,  0x246D,  0x246E,  0x246F,  
      0x2470,  0x2471,  0x2472,  0x2473,  0,       0,       0,       0,       // 0x855x
      0,       0,       0,       0,       0,       0,       0x2474,  0x2475,  
      0x2476,  0x2477,  0x2478,  0x2479,  0x247A,  0x247B,  0x247C,  0x247D,  // 0x856x
      0x247E,  0x247F,  0x2480,  0x2481,  0x2482,  0x2483,  0x2484,  0x2485,  
      0x2486,  0x2487,  0,       0,       0,       0,       0,       0,       // 0x857x
      0,       0,       0,       0,       0x2776,  0x2777,  0x2778,  0,       
      0x2779,  0x277A,  0x277B,  0x277C,  0x277D,  0x277E,  0,       0,       // 0x858x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xFFFF,  0x2488,  0x2489,  0x248A,  0x248B,  0x248C,  0x248D,  // 0x859x
      0x248E,  0x248F,  0x2490,  0,       0,       0,       0,       0x2160,  
      0x2161,  0x2162,  0x2163,  0x2164,  0x2165,  0x2166,  0x2167,  0x2168,  // 0x85Ax
      0x2169,  0x216A,  0x216B,  0xFFFF,  0xFFFF,  0xFFFF,  0,       0,       
      0,       0,       0,       0x2170,  0x2171,  0x2172,  0x2173,  0x2174,  // 0x85Bx
      0x2175,  0x2176,  0x2177,  0x2178,  0x2179,  0x217A,  0x217B,  0xFFFF,  
      0xFFFF,  0xFFFF,  0,       0,       0,       0,       0,       0,       // 0x85Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x85Dx
      0,       0,       0,       0x249C,  0x249D,  0x249E,  0x249F,  0x24A0,  
      0x24A1,  0x24A2,  0x24A3,  0x24A4,  0x24A5,  0x24A6,  0x24A7,  0x24A8,  // 0x85Ex
      0x24A9,  0x24AA,  0x24AB,  0x24AC,  0x24AD,  0x24AE,  0x24AF,  0x24B0,  
      0x24B1,  0x24B2,  0x24B3,  0x24B4,  0x24B5,  0,       0,       0,       // 0x85Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Sjis2uniTable_Mac_86 [] = {
      0x339C,  0x339F,  0x339D,  0x33A0,  0x33A4,  0xFF4D,  0x33A1,  0x33A5,  // 0x864x
      0x339E,  0x33A2,  0x338E,  0xFF47,  0x338F,  0x33C4,  0x3396,  0x3397,  
      0x2113,  0x3398,  0x33B3,  0x33B2,  0x33B1,  0x33B0,  0x2109,  0x33D4,  // 0x865x
      0x33CB,  0x3390,  0x3385,  0x3386,  0x3387,  0xFFFF,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x866x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x867x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x868x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x869x
      0,       0,       0,       0x2116,  0x33CD,  0x2121,  0xFFFF,  0x2664,  
      0x2667,  0x2661,  0x2662,  0x2660,  0x2663,  0x2665,  0x2666,  0,       // 0x86Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x3020,  0x260E,  0x3004,  0,       0,       // 0x86Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x261E,  // 0x86Cx
      0x261C,  0x261D,  0x261F,  0x21C6,  0x21C4,  0x21C5,  0xFFFF,  0x21E8,  
      0x21E6,  0x21E7,  0x21E9,  0x21E8,  0x21E6,  0x21E7,  0x21E9,  0,       // 0x86Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x86Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x86Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Sjis2uniTable_Mac_87 [] = {
      0x3230,  0x322A,  0x322B,  0x322C,  0x322D,  0x322E,  0x322F,  0x3240,  // 0x874x
      0x3237,  0x3242,  0x3243,  0x3239,  0x323A,  0x3231,  0x323E,  0x3234,  
      0x3232,  0x323B,  0x3236,  0x3233,  0x3235,  0x323C,  0x323D,  0x323F,  // 0x875x
      0x3238,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x876x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x877x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x878x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xFFFF,  0xFFFF,  0x32A4,  0x32A5,  0x32A6,  0x32A7,  0x32A8,  // 0x879x
      0x32A9,  0x3296,  0x329D,  0x3298,  0x329E,  0xFFFF,  0x3299,  0x3349,  
      0x3322,  0x334D,  0x3314,  0x3316,  0x3305,  0x3333,  0x334E,  0x3303,  // 0x87Ax
      0x3336,  0x3318,  0x3315,  0x3327,  0x3351,  0x334A,  0x3339,  0x3357,  
      0x330D,  0x3342,  0x3323,  0x3326,  0x333B,  0x332B,  0,       0,       // 0x87Bx
      0,       0,       0,       0,       0,       0x3300,  0x331E,  0x332A,  
      0x3331,  0x3347,  0,       0,       0,       0,       0,       0,       // 0x87Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0x337E,  0x337D,  0x337C,  // 0x87Ex
      0x337B,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Fx
      0,       0,       0x337F,  0xFFFF,  0xFFFF,  0,       0,       0,       
} ;


static const unsigned short Sjis2uniTable_Mac_88 [] = {
      0x222E,  0x221F,  0x22BF,  0,       0,       0,       0,       0,       // 0x884x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x301D,  0x301F,  0,       0,       // 0x885x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x886x
      0x3094,  0,       0x30F7,  0x30F8,  0x30F9,  0x30FA,  0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x887x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x888x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x889x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x88Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Sjis2uniTable_Mac_89  NULL
#define  Sjis2uniTable_Mac_8A  NULL
#define  Sjis2uniTable_Mac_8B  NULL
#define  Sjis2uniTable_Mac_8C  NULL
#define  Sjis2uniTable_Mac_8D  NULL
#define  Sjis2uniTable_Mac_8E  NULL
#define  Sjis2uniTable_Mac_8F  NULL
#define  Sjis2uniTable_Mac_90  NULL
#define  Sjis2uniTable_Mac_91  NULL
#define  Sjis2uniTable_Mac_92  NULL
#define  Sjis2uniTable_Mac_93  NULL
#define  Sjis2uniTable_Mac_94  NULL
#define  Sjis2uniTable_Mac_95  NULL
#define  Sjis2uniTable_Mac_96  NULL
#define  Sjis2uniTable_Mac_97  NULL
#define  Sjis2uniTable_Mac_98  NULL
#define  Sjis2uniTable_Mac_99  NULL
#define  Sjis2uniTable_Mac_9A  NULL
#define  Sjis2uniTable_Mac_9B  NULL
#define  Sjis2uniTable_Mac_9C  NULL
#define  Sjis2uniTable_Mac_9D  NULL
#define  Sjis2uniTable_Mac_9E  NULL
#define  Sjis2uniTable_Mac_9F  NULL
#define  Sjis2uniTable_Mac_A0  NULL
#define  Sjis2uniTable_Mac_A1  NULL
#define  Sjis2uniTable_Mac_A2  NULL
#define  Sjis2uniTable_Mac_A3  NULL
#define  Sjis2uniTable_Mac_A4  NULL
#define  Sjis2uniTable_Mac_A5  NULL
#define  Sjis2uniTable_Mac_A6  NULL
#define  Sjis2uniTable_Mac_A7  NULL
#define  Sjis2uniTable_Mac_A8  NULL
#define  Sjis2uniTable_Mac_A9  NULL
#define  Sjis2uniTable_Mac_AA  NULL
#define  Sjis2uniTable_Mac_AB  NULL
#define  Sjis2uniTable_Mac_AC  NULL
#define  Sjis2uniTable_Mac_AD  NULL
#define  Sjis2uniTable_Mac_AE  NULL
#define  Sjis2uniTable_Mac_AF  NULL
#define  Sjis2uniTable_Mac_B0  NULL
#define  Sjis2uniTable_Mac_B1  NULL
#define  Sjis2uniTable_Mac_B2  NULL
#define  Sjis2uniTable_Mac_B3  NULL
#define  Sjis2uniTable_Mac_B4  NULL
#define  Sjis2uniTable_Mac_B5  NULL
#define  Sjis2uniTable_Mac_B6  NULL
#define  Sjis2uniTable_Mac_B7  NULL
#define  Sjis2uniTable_Mac_B8  NULL
#define  Sjis2uniTable_Mac_B9  NULL
#define  Sjis2uniTable_Mac_BA  NULL
#define  Sjis2uniTable_Mac_BB  NULL
#define  Sjis2uniTable_Mac_BC  NULL
#define  Sjis2uniTable_Mac_BD  NULL
#define  Sjis2uniTable_Mac_BE  NULL
#define  Sjis2uniTable_Mac_BF  NULL
#define  Sjis2uniTable_Mac_C0  NULL
#define  Sjis2uniTable_Mac_C1  NULL
#define  Sjis2uniTable_Mac_C2  NULL
#define  Sjis2uniTable_Mac_C3  NULL
#define  Sjis2uniTable_Mac_C4  NULL
#define  Sjis2uniTable_Mac_C5  NULL
#define  Sjis2uniTable_Mac_C6  NULL
#define  Sjis2uniTable_Mac_C7  NULL
#define  Sjis2uniTable_Mac_C8  NULL
#define  Sjis2uniTable_Mac_C9  NULL
#define  Sjis2uniTable_Mac_CA  NULL
#define  Sjis2uniTable_Mac_CB  NULL
#define  Sjis2uniTable_Mac_CC  NULL
#define  Sjis2uniTable_Mac_CD  NULL
#define  Sjis2uniTable_Mac_CE  NULL
#define  Sjis2uniTable_Mac_CF  NULL
#define  Sjis2uniTable_Mac_D0  NULL
#define  Sjis2uniTable_Mac_D1  NULL
#define  Sjis2uniTable_Mac_D2  NULL
#define  Sjis2uniTable_Mac_D3  NULL
#define  Sjis2uniTable_Mac_D4  NULL
#define  Sjis2uniTable_Mac_D5  NULL
#define  Sjis2uniTable_Mac_D6  NULL
#define  Sjis2uniTable_Mac_D7  NULL
#define  Sjis2uniTable_Mac_D8  NULL
#define  Sjis2uniTable_Mac_D9  NULL
#define  Sjis2uniTable_Mac_DA  NULL
#define  Sjis2uniTable_Mac_DB  NULL
#define  Sjis2uniTable_Mac_DC  NULL
#define  Sjis2uniTable_Mac_DD  NULL
#define  Sjis2uniTable_Mac_DE  NULL
#define  Sjis2uniTable_Mac_DF  NULL
#define  Sjis2uniTable_Mac_E0  NULL
#define  Sjis2uniTable_Mac_E1  NULL
#define  Sjis2uniTable_Mac_E2  NULL
#define  Sjis2uniTable_Mac_E3  NULL
#define  Sjis2uniTable_Mac_E4  NULL
#define  Sjis2uniTable_Mac_E5  NULL
#define  Sjis2uniTable_Mac_E6  NULL
#define  Sjis2uniTable_Mac_E7  NULL
#define  Sjis2uniTable_Mac_E8  NULL
#define  Sjis2uniTable_Mac_E9  NULL
#define  Sjis2uniTable_Mac_EA  NULL

static const unsigned short Sjis2uniTable_Mac_EB [] = {
      0,       0x3001,  0x3002,  0,       0,       0,       0,       0,       // 0xEB4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xFFE3,  0xFE33,  0,       0,       0,       0,       0,       0,       // 0xEB5x
      0,       0,       0,       0x30FC,  0xFE31,  0x2010,  0,       0,       
      0x301C,  0x2016,  0xFF5C,  0x2026,  0xFE30,  0,       0,       0,       // 0xEB6x
      0,       0xFE35,  0xFE36,  0xFE39,  0xFE3A,  0xFF3B,  0xFF3D,  0xFE37,  
      0xFE38,  0xFE3F,  0xFE40,  0xFE3D,  0xFE3E,  0xFE41,  0xFE42,  0xFE43,  // 0xEB7x
      0xFE44,  0xFE3B,  0xFE3C,  0,       0,       0,       0,       0,       
      0,       0xFF1D,  0,       0,       0,       0,       0,       0,       // 0xEB8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEB9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEBFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Sjis2uniTable_Mac_EC [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEC9x
      0,       0,       0,       0,       0,       0,       0,       0x3041,  
      0,       0x3043,  0,       0x3045,  0,       0x3047,  0,       0x3049,  // 0xECAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xECBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x3063,  0,       0,       0,       0,       0,       0,       // 0xECCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xECDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x3083,  0,       0x3085,  0,       0x3087,  0,       0,       // 0xECEx
      0,       0,       0,       0,       0x308E,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xECFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Sjis2uniTable_Mac_ED [] = {
      0x30A1,  0,       0x30A3,  0,       0x30A5,  0,       0x30A7,  0,       // 0xED4x
      0x30A9,  0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xED5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x30C3,  0,       0,       0,       0,       0,       // 0xED6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xED7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x30E3,  0,       0x30E5,  0,       0x30E7,  // 0xED8x
      0,       0,       0,       0,       0,       0,       0x30EE,  0,       
      0,       0,       0,       0,       0,       0x30F5,  0x30F6,  0,       // 0xED9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xEDFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Sjis2uniTable_Mac_EE  NULL
#define  Sjis2uniTable_Mac_EF  NULL
#define  Sjis2uniTable_Mac_F0  NULL
#define  Sjis2uniTable_Mac_F1  NULL
#define  Sjis2uniTable_Mac_F2  NULL
#define  Sjis2uniTable_Mac_F3  NULL
#define  Sjis2uniTable_Mac_F4  NULL
#define  Sjis2uniTable_Mac_F5  NULL
#define  Sjis2uniTable_Mac_F6  NULL
#define  Sjis2uniTable_Mac_F7  NULL
#define  Sjis2uniTable_Mac_F8  NULL
#define  Sjis2uniTable_Mac_F9  NULL
#define  Sjis2uniTable_Mac_FA  NULL
#define  Sjis2uniTable_Mac_FB  NULL
#define  Sjis2uniTable_Mac_FC  NULL
#define  Sjis2uniTable_Mac_FD  NULL
#define  Sjis2uniTable_Mac_FE  NULL
#define  Sjis2uniTable_Mac_FF  NULL


const unsigned short *Sjis2uniTable_Mac ( int C ) {

   static const unsigned short *const Sjis2uniTable_Mac_80_FF [] = {
      Sjis2uniTable_Mac_80, Sjis2uniTable_Mac_81, Sjis2uniTable_Mac_82, Sjis2uniTable_Mac_83,
      Sjis2uniTable_Mac_84, Sjis2uniTable_Mac_85, Sjis2uniTable_Mac_86, Sjis2uniTable_Mac_87,
      Sjis2uniTable_Mac_88, Sjis2uniTable_Mac_89, Sjis2uniTable_Mac_8A, Sjis2uniTable_Mac_8B,
      Sjis2uniTable_Mac_8C, Sjis2uniTable_Mac_8D, Sjis2uniTable_Mac_8E, Sjis2uniTable_Mac_8F,

      Sjis2uniTable_Mac_90, Sjis2uniTable_Mac_91, Sjis2uniTable_Mac_92, Sjis2uniTable_Mac_93,
      Sjis2uniTable_Mac_94, Sjis2uniTable_Mac_95, Sjis2uniTable_Mac_96, Sjis2uniTable_Mac_97,
      Sjis2uniTable_Mac_98, Sjis2uniTable_Mac_99, Sjis2uniTable_Mac_9A, Sjis2uniTable_Mac_9B,
      Sjis2uniTable_Mac_9C, Sjis2uniTable_Mac_9D, Sjis2uniTable_Mac_9E, Sjis2uniTable_Mac_9F,

      Sjis2uniTable_Mac_A0, Sjis2uniTable_Mac_A1, Sjis2uniTable_Mac_A2, Sjis2uniTable_Mac_A3,
      Sjis2uniTable_Mac_A4, Sjis2uniTable_Mac_A5, Sjis2uniTable_Mac_A6, Sjis2uniTable_Mac_A7,
      Sjis2uniTable_Mac_A8, Sjis2uniTable_Mac_A9, Sjis2uniTable_Mac_AA, Sjis2uniTable_Mac_AB,
      Sjis2uniTable_Mac_AC, Sjis2uniTable_Mac_AD, Sjis2uniTable_Mac_AE, Sjis2uniTable_Mac_AF,

      Sjis2uniTable_Mac_B0, Sjis2uniTable_Mac_B1, Sjis2uniTable_Mac_B2, Sjis2uniTable_Mac_B3,
      Sjis2uniTable_Mac_B4, Sjis2uniTable_Mac_B5, Sjis2uniTable_Mac_B6, Sjis2uniTable_Mac_B7,
      Sjis2uniTable_Mac_B8, Sjis2uniTable_Mac_B9, Sjis2uniTable_Mac_BA, Sjis2uniTable_Mac_BB,
      Sjis2uniTable_Mac_BC, Sjis2uniTable_Mac_BD, Sjis2uniTable_Mac_BE, Sjis2uniTable_Mac_BF,

      Sjis2uniTable_Mac_C0, Sjis2uniTable_Mac_C1, Sjis2uniTable_Mac_C2, Sjis2uniTable_Mac_C3,
      Sjis2uniTable_Mac_C4, Sjis2uniTable_Mac_C5, Sjis2uniTable_Mac_C6, Sjis2uniTable_Mac_C7,
      Sjis2uniTable_Mac_C8, Sjis2uniTable_Mac_C9, Sjis2uniTable_Mac_CA, Sjis2uniTable_Mac_CB,
      Sjis2uniTable_Mac_CC, Sjis2uniTable_Mac_CD, Sjis2uniTable_Mac_CE, Sjis2uniTable_Mac_CF,

      Sjis2uniTable_Mac_D0, Sjis2uniTable_Mac_D1, Sjis2uniTable_Mac_D2, Sjis2uniTable_Mac_D3,
      Sjis2uniTable_Mac_D4, Sjis2uniTable_Mac_D5, Sjis2uniTable_Mac_D6, Sjis2uniTable_Mac_D7,
      Sjis2uniTable_Mac_D8, Sjis2uniTable_Mac_D9, Sjis2uniTable_Mac_DA, Sjis2uniTable_Mac_DB,
      Sjis2uniTable_Mac_DC, Sjis2uniTable_Mac_DD, Sjis2uniTable_Mac_DE, Sjis2uniTable_Mac_DF,

      Sjis2uniTable_Mac_E0, Sjis2uniTable_Mac_E1, Sjis2uniTable_Mac_E2, Sjis2uniTable_Mac_E3,
      Sjis2uniTable_Mac_E4, Sjis2uniTable_Mac_E5, Sjis2uniTable_Mac_E6, Sjis2uniTable_Mac_E7,
      Sjis2uniTable_Mac_E8, Sjis2uniTable_Mac_E9, Sjis2uniTable_Mac_EA, Sjis2uniTable_Mac_EB,
      Sjis2uniTable_Mac_EC, Sjis2uniTable_Mac_ED, Sjis2uniTable_Mac_EE, Sjis2uniTable_Mac_EF,

      Sjis2uniTable_Mac_F0, Sjis2uniTable_Mac_F1, Sjis2uniTable_Mac_F2, Sjis2uniTable_Mac_F3,
      Sjis2uniTable_Mac_F4, Sjis2uniTable_Mac_F5, Sjis2uniTable_Mac_F6, Sjis2uniTable_Mac_F7,
      Sjis2uniTable_Mac_F8, Sjis2uniTable_Mac_F9, Sjis2uniTable_Mac_FA, Sjis2uniTable_Mac_FB,
      Sjis2uniTable_Mac_FC, Sjis2uniTable_Mac_FD, Sjis2uniTable_Mac_FE, Sjis2uniTable_Mac_FF,
   } ;

   if ( C >= 0x80 && C <= 0xFF ) return Sjis2uniTable_Mac_80_FF [ C - 0x80 ] ;

   return NULL ;
}



int Sjis2uni_Mac_SingleByte ( int cSjis, int cUnicode ) {
   if ( cSjis == 0x80 ) return 0x005C ;
   if ( cSjis == 0xA0 ) return 0x00A0 ;
   if ( cSjis == 0xFD ) return 0x00A9 ;
   if ( cSjis == 0xFE ) return 0x2122 ;
   if ( cSjis == 0xFF ) return 0x2026 ;
   return cUnicode ;
}




const wchar_t *Sjis2uni_Mac_Composition ( int cSjis ) {
   switch ( cSjis ) {
      case 0x8591 : return L"0." ;
      case 0x85AB : return L"XIII" ;
      case 0x85AC : return L"XIV" ;
      case 0x85AD : return L"XV" ;
      case 0x85BF : return L"xiii" ;
      case 0x85C0 : return L"xiv" ;
      case 0x85C1 : return L"xv" ;
      case 0x865D : return L"TB" ;
      case 0x869E : return L"FAX" ;
      case 0x86CE : return L"\x2193\x2191" ;    // ""
      case 0x8791 : return L"(\x5927)" ;     // "()"
      case 0x8792 : return L"(\x5C0F)" ;     // "()"
      case 0x879D : return L"(\x63A7)" ;     // "(T)"
      case 0x87FB : return L"\x6709\x9650\x4F1A\x793E" ;    // "L"
      case 0x87FC : return L"\x8CA1\x56E3\x6CD5\x4EBA" ;    // "c@l"
   }
   return NULL ;
}




///////////////////////////////////////////////////////////////////////////////////////
//                          UNICODE --> Macintosh Shift-JIS
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short Uni2sjisTable_Mac_00 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x000x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x001x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x002x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x003x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x004x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x005x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x006x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x007x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x008x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x009x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x00A0,  0,       0x8191,  0x8192,  0,       0,       0,       0,       // 0x00Ax
      0,       0x00FD,  0,       0,       0x81CA,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_01  NULL
#define  Uni2sjisTable_Mac_02  NULL
#define  Uni2sjisTable_Mac_03  NULL
#define  Uni2sjisTable_Mac_04  NULL
#define  Uni2sjisTable_Mac_05  NULL
#define  Uni2sjisTable_Mac_06  NULL
#define  Uni2sjisTable_Mac_07  NULL
#define  Uni2sjisTable_Mac_08  NULL
#define  Uni2sjisTable_Mac_09  NULL
#define  Uni2sjisTable_Mac_0A  NULL
#define  Uni2sjisTable_Mac_0B  NULL
#define  Uni2sjisTable_Mac_0C  NULL
#define  Uni2sjisTable_Mac_0D  NULL
#define  Uni2sjisTable_Mac_0E  NULL
#define  Uni2sjisTable_Mac_0F  NULL
#define  Uni2sjisTable_Mac_10  NULL
#define  Uni2sjisTable_Mac_11  NULL
#define  Uni2sjisTable_Mac_12  NULL
#define  Uni2sjisTable_Mac_13  NULL
#define  Uni2sjisTable_Mac_14  NULL
#define  Uni2sjisTable_Mac_15  NULL
#define  Uni2sjisTable_Mac_16  NULL
#define  Uni2sjisTable_Mac_17  NULL
#define  Uni2sjisTable_Mac_18  NULL
#define  Uni2sjisTable_Mac_19  NULL
#define  Uni2sjisTable_Mac_1A  NULL
#define  Uni2sjisTable_Mac_1B  NULL
#define  Uni2sjisTable_Mac_1C  NULL
#define  Uni2sjisTable_Mac_1D  NULL
#define  Uni2sjisTable_Mac_1E  NULL
#define  Uni2sjisTable_Mac_1F  NULL

static const unsigned short Uni2sjisTable_Mac_20 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x200x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x815C,  0,       0x8161,  0,       // 0x201x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x202x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x203x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x204x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x205x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x206x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x207x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x208x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x209x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x20Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2sjisTable_Mac_21 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x210x
      0,       0x8656,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0x8650,  0,       0,       0x869B,  0,       // 0x211x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x869D,  0x00FE,  0,       0,       0,       0,       0,       // 0x212x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x213x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x214x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x215x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x859F,  0x85A0,  0x85A1,  0x85A2,  0x85A3,  0x85A4,  0x85A5,  0x85A6,  // 0x216x
      0x85A7,  0x85A8,  0x85A9,  0x85AA,  0,       0,       0,       0,       
      0x85B3,  0x85B4,  0x85B5,  0x85B6,  0x85B7,  0x85B8,  0x85B9,  0x85BA,  // 0x217x
      0x85BB,  0x85BC,  0x85BD,  0x85BE,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x218x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x219x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x86CC,  0x86CD,  0x86CB,  0,       // 0x21Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x86D0,  0x86D1,  // 0x21Ex
      0x86CF,  0x86D2,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x21Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2sjisTable_Mac_22 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x220x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x817C,  0,       0,       0,       0,       0,       // 0x221x
      0,       0,       0,       0,       0,       0,       0,       0x8841,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x222x
      0,       0,       0,       0,       0,       0,       0x8840,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x223x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x224x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x225x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x226x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x227x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x228x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x229x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Bx
      0,       0,       0,       0,       0,       0,       0,       0x8842,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x22Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_23  NULL

static const unsigned short Uni2sjisTable_Mac_24 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x240x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x241x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x242x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x243x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x244x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x245x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x8540,  0x8541,  0x8542,  0x8543,  0x8544,  0x8545,  0x8546,  0x8547,  // 0x246x
      0x8548,  0x8549,  0x854A,  0x854B,  0x854C,  0x854D,  0x854E,  0x854F,  
      0x8550,  0x8551,  0x8552,  0x8553,  0x855E,  0x855F,  0x8560,  0x8561,  // 0x247x
      0x8562,  0x8563,  0x8564,  0x8565,  0x8566,  0x8567,  0x8568,  0x8569,  
      0x856A,  0x856B,  0x856C,  0x856D,  0x856E,  0x856F,  0x8570,  0x8571,  // 0x248x
      0x8592,  0x8593,  0x8594,  0x8595,  0x8596,  0x8597,  0x8598,  0x8599,  
      0x859A,  0,       0,       0,       0,       0,       0,       0,       // 0x249x
      0,       0,       0,       0,       0x85DB,  0x85DC,  0x85DD,  0x85DE,  
      0x85DF,  0x85E0,  0x85E1,  0x85E2,  0x85E3,  0x85E4,  0x85E5,  0x85E6,  // 0x24Ax
      0x85E7,  0x85E8,  0x85E9,  0x85EA,  0x85EB,  0x85EC,  0x85ED,  0x85EE,  
      0x85EF,  0x85F0,  0x85F1,  0x85F2,  0x85F3,  0x85F4,  0,       0,       // 0x24Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x24Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_25  NULL

static const unsigned short Uni2sjisTable_Mac_26 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x260x
      0,       0,       0,       0,       0,       0,       0x86B4,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x261x
      0,       0,       0,       0,       0x86C8,  0x86C9,  0x86C7,  0x86CA,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x262x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x263x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x264x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x265x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x86A3,  0x86A1,  0x86A2,  0x86A4,  0x869F,  0x86A5,  0x86A6,  0x86A0,  // 0x266x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x267x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x268x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x269x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x26Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2sjisTable_Mac_27 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x270x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x271x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x272x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x273x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x274x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x275x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x276x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x857C,  0x857D,  // 0x277x
      0x857E,  0x8580,  0x8581,  0x8582,  0x8583,  0x8584,  0x8585,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x278x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x279x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x27Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_28  NULL
#define  Uni2sjisTable_Mac_29  NULL
#define  Uni2sjisTable_Mac_2A  NULL
#define  Uni2sjisTable_Mac_2B  NULL
#define  Uni2sjisTable_Mac_2C  NULL
#define  Uni2sjisTable_Mac_2D  NULL
#define  Uni2sjisTable_Mac_2E  NULL
#define  Uni2sjisTable_Mac_2F  NULL

static const unsigned short Uni2sjisTable_Mac_30 [] = {
      0,       0,       0,       0,       0x86B5,  0,       0,       0,       // 0x300x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x301x
      0,       0,       0,       0,       0x8160,  0x8854,  0,       0x8855,  
      0x86B3,  0,       0,       0,       0,       0,       0,       0,       // 0x302x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x303x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x304x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x305x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x306x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x307x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x308x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x8868,  0,       0,       0,       // 0x309x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x30Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0x886A,  // 0x30Fx
      0x886B,  0x886C,  0x886D,  0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_31  NULL

static const unsigned short Uni2sjisTable_Mac_32 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x320x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x321x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x322x
      0,       0,       0x8741,  0x8742,  0x8743,  0x8744,  0x8745,  0x8746,  
      0x8740,  0x874D,  0x8750,  0x8753,  0x874F,  0x8754,  0x8752,  0x8748,  // 0x323x
      0x8758,  0x874B,  0x874C,  0x8751,  0x8755,  0x8756,  0x874E,  0x8757,  
      0x8747,  0,       0x8749,  0x874A,  0,       0,       0,       0,       // 0x324x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x325x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x326x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x327x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x328x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x8799,  0,       // 0x329x
      0x879B,  0x879E,  0,       0,       0,       0x879A,  0x879C,  0,       
      0,       0,       0,       0,       0x8793,  0x8794,  0x8795,  0x8796,  // 0x32Ax
      0x8797,  0x8798,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x32Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short Uni2sjisTable_Mac_33 [] = {
      0x87BD,  0,       0,       0x87A7,  0,       0x87A4,  0,       0,       // 0x330x
      0,       0,       0,       0,       0,       0x87B0,  0,       0,       
      0,       0,       0,       0,       0x87A2,  0x87AA,  0x87A3,  0,       // 0x331x
      0x87A9,  0,       0,       0,       0,       0,       0x87BE,  0,       
      0,       0,       0x87A0,  0x87B2,  0,       0,       0x87B3,  0x87AB,  // 0x332x
      0,       0,       0x87BF,  0x87B5,  0,       0,       0,       0,       
      0,       0x87C0,  0,       0x87A5,  0,       0,       0x87A8,  0,       // 0x333x
      0,       0x87AE,  0,       0x87B4,  0,       0,       0,       0,       
      0,       0,       0x87B1,  0,       0,       0,       0,       0x87C1,  // 0x334x
      0,       0x879F,  0x87AD,  0,       0,       0x87A1,  0x87A6,  0,       
      0,       0x87AC,  0,       0,       0,       0,       0,       0x87AF,  // 0x335x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x336x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x337x
      0,       0,       0,       0x87E8,  0x87E7,  0x87E6,  0x87E5,  0x87FA,  
      0,       0,       0,       0,       0,       0x865A,  0x865B,  0x865C,  // 0x338x
      0,       0,       0,       0,       0,       0,       0x864A,  0x864C,  
      0x8659,  0,       0,       0,       0,       0,       0x864E,  0x864F,  // 0x339x
      0x8651,  0,       0,       0,       0x8640,  0x8642,  0x8648,  0x8641,  
      0x8643,  0x8646,  0x8649,  0,       0x8644,  0x8647,  0,       0,       // 0x33Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0x8655,  0x8654,  0x8653,  0x8652,  0,       0,       0,       0,       // 0x33Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0x864D,  0,       0,       0,       // 0x33Cx
      0,       0,       0,       0x8658,  0,       0x869C,  0,       0,       
      0,       0,       0,       0,       0x8657,  0,       0,       0,       // 0x33Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x33Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x33Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_34  NULL
#define  Uni2sjisTable_Mac_35  NULL
#define  Uni2sjisTable_Mac_36  NULL
#define  Uni2sjisTable_Mac_37  NULL
#define  Uni2sjisTable_Mac_38  NULL
#define  Uni2sjisTable_Mac_39  NULL
#define  Uni2sjisTable_Mac_3A  NULL
#define  Uni2sjisTable_Mac_3B  NULL
#define  Uni2sjisTable_Mac_3C  NULL
#define  Uni2sjisTable_Mac_3D  NULL
#define  Uni2sjisTable_Mac_3E  NULL
#define  Uni2sjisTable_Mac_3F  NULL
#define  Uni2sjisTable_Mac_40  NULL
#define  Uni2sjisTable_Mac_41  NULL
#define  Uni2sjisTable_Mac_42  NULL
#define  Uni2sjisTable_Mac_43  NULL
#define  Uni2sjisTable_Mac_44  NULL
#define  Uni2sjisTable_Mac_45  NULL
#define  Uni2sjisTable_Mac_46  NULL
#define  Uni2sjisTable_Mac_47  NULL
#define  Uni2sjisTable_Mac_48  NULL
#define  Uni2sjisTable_Mac_49  NULL
#define  Uni2sjisTable_Mac_4A  NULL
#define  Uni2sjisTable_Mac_4B  NULL
#define  Uni2sjisTable_Mac_4C  NULL
#define  Uni2sjisTable_Mac_4D  NULL
#define  Uni2sjisTable_Mac_4E  NULL
#define  Uni2sjisTable_Mac_4F  NULL
#define  Uni2sjisTable_Mac_50  NULL
#define  Uni2sjisTable_Mac_51  NULL
#define  Uni2sjisTable_Mac_52  NULL
#define  Uni2sjisTable_Mac_53  NULL
#define  Uni2sjisTable_Mac_54  NULL
#define  Uni2sjisTable_Mac_55  NULL
#define  Uni2sjisTable_Mac_56  NULL
#define  Uni2sjisTable_Mac_57  NULL
#define  Uni2sjisTable_Mac_58  NULL
#define  Uni2sjisTable_Mac_59  NULL
#define  Uni2sjisTable_Mac_5A  NULL
#define  Uni2sjisTable_Mac_5B  NULL
#define  Uni2sjisTable_Mac_5C  NULL
#define  Uni2sjisTable_Mac_5D  NULL
#define  Uni2sjisTable_Mac_5E  NULL
#define  Uni2sjisTable_Mac_5F  NULL
#define  Uni2sjisTable_Mac_60  NULL
#define  Uni2sjisTable_Mac_61  NULL
#define  Uni2sjisTable_Mac_62  NULL
#define  Uni2sjisTable_Mac_63  NULL
#define  Uni2sjisTable_Mac_64  NULL
#define  Uni2sjisTable_Mac_65  NULL
#define  Uni2sjisTable_Mac_66  NULL
#define  Uni2sjisTable_Mac_67  NULL
#define  Uni2sjisTable_Mac_68  NULL
#define  Uni2sjisTable_Mac_69  NULL
#define  Uni2sjisTable_Mac_6A  NULL
#define  Uni2sjisTable_Mac_6B  NULL
#define  Uni2sjisTable_Mac_6C  NULL
#define  Uni2sjisTable_Mac_6D  NULL
#define  Uni2sjisTable_Mac_6E  NULL
#define  Uni2sjisTable_Mac_6F  NULL
#define  Uni2sjisTable_Mac_70  NULL
#define  Uni2sjisTable_Mac_71  NULL
#define  Uni2sjisTable_Mac_72  NULL
#define  Uni2sjisTable_Mac_73  NULL
#define  Uni2sjisTable_Mac_74  NULL
#define  Uni2sjisTable_Mac_75  NULL
#define  Uni2sjisTable_Mac_76  NULL
#define  Uni2sjisTable_Mac_77  NULL
#define  Uni2sjisTable_Mac_78  NULL
#define  Uni2sjisTable_Mac_79  NULL
#define  Uni2sjisTable_Mac_7A  NULL
#define  Uni2sjisTable_Mac_7B  NULL
#define  Uni2sjisTable_Mac_7C  NULL
#define  Uni2sjisTable_Mac_7D  NULL
#define  Uni2sjisTable_Mac_7E  NULL
#define  Uni2sjisTable_Mac_7F  NULL
#define  Uni2sjisTable_Mac_80  NULL
#define  Uni2sjisTable_Mac_81  NULL
#define  Uni2sjisTable_Mac_82  NULL
#define  Uni2sjisTable_Mac_83  NULL
#define  Uni2sjisTable_Mac_84  NULL
#define  Uni2sjisTable_Mac_85  NULL
#define  Uni2sjisTable_Mac_86  NULL
#define  Uni2sjisTable_Mac_87  NULL
#define  Uni2sjisTable_Mac_88  NULL
#define  Uni2sjisTable_Mac_89  NULL
#define  Uni2sjisTable_Mac_8A  NULL
#define  Uni2sjisTable_Mac_8B  NULL
#define  Uni2sjisTable_Mac_8C  NULL
#define  Uni2sjisTable_Mac_8D  NULL
#define  Uni2sjisTable_Mac_8E  NULL
#define  Uni2sjisTable_Mac_8F  NULL
#define  Uni2sjisTable_Mac_90  NULL
#define  Uni2sjisTable_Mac_91  NULL
#define  Uni2sjisTable_Mac_92  NULL
#define  Uni2sjisTable_Mac_93  NULL
#define  Uni2sjisTable_Mac_94  NULL
#define  Uni2sjisTable_Mac_95  NULL
#define  Uni2sjisTable_Mac_96  NULL
#define  Uni2sjisTable_Mac_97  NULL
#define  Uni2sjisTable_Mac_98  NULL
#define  Uni2sjisTable_Mac_99  NULL
#define  Uni2sjisTable_Mac_9A  NULL
#define  Uni2sjisTable_Mac_9B  NULL
#define  Uni2sjisTable_Mac_9C  NULL
#define  Uni2sjisTable_Mac_9D  NULL
#define  Uni2sjisTable_Mac_9E  NULL
#define  Uni2sjisTable_Mac_9F  NULL
#define  Uni2sjisTable_Mac_A0  NULL
#define  Uni2sjisTable_Mac_A1  NULL
#define  Uni2sjisTable_Mac_A2  NULL
#define  Uni2sjisTable_Mac_A3  NULL
#define  Uni2sjisTable_Mac_A4  NULL
#define  Uni2sjisTable_Mac_A5  NULL
#define  Uni2sjisTable_Mac_A6  NULL
#define  Uni2sjisTable_Mac_A7  NULL
#define  Uni2sjisTable_Mac_A8  NULL
#define  Uni2sjisTable_Mac_A9  NULL
#define  Uni2sjisTable_Mac_AA  NULL
#define  Uni2sjisTable_Mac_AB  NULL
#define  Uni2sjisTable_Mac_AC  NULL
#define  Uni2sjisTable_Mac_AD  NULL
#define  Uni2sjisTable_Mac_AE  NULL
#define  Uni2sjisTable_Mac_AF  NULL
#define  Uni2sjisTable_Mac_B0  NULL
#define  Uni2sjisTable_Mac_B1  NULL
#define  Uni2sjisTable_Mac_B2  NULL
#define  Uni2sjisTable_Mac_B3  NULL
#define  Uni2sjisTable_Mac_B4  NULL
#define  Uni2sjisTable_Mac_B5  NULL
#define  Uni2sjisTable_Mac_B6  NULL
#define  Uni2sjisTable_Mac_B7  NULL
#define  Uni2sjisTable_Mac_B8  NULL
#define  Uni2sjisTable_Mac_B9  NULL
#define  Uni2sjisTable_Mac_BA  NULL
#define  Uni2sjisTable_Mac_BB  NULL
#define  Uni2sjisTable_Mac_BC  NULL
#define  Uni2sjisTable_Mac_BD  NULL
#define  Uni2sjisTable_Mac_BE  NULL
#define  Uni2sjisTable_Mac_BF  NULL
#define  Uni2sjisTable_Mac_C0  NULL
#define  Uni2sjisTable_Mac_C1  NULL
#define  Uni2sjisTable_Mac_C2  NULL
#define  Uni2sjisTable_Mac_C3  NULL
#define  Uni2sjisTable_Mac_C4  NULL
#define  Uni2sjisTable_Mac_C5  NULL
#define  Uni2sjisTable_Mac_C6  NULL
#define  Uni2sjisTable_Mac_C7  NULL
#define  Uni2sjisTable_Mac_C8  NULL
#define  Uni2sjisTable_Mac_C9  NULL
#define  Uni2sjisTable_Mac_CA  NULL
#define  Uni2sjisTable_Mac_CB  NULL
#define  Uni2sjisTable_Mac_CC  NULL
#define  Uni2sjisTable_Mac_CD  NULL
#define  Uni2sjisTable_Mac_CE  NULL
#define  Uni2sjisTable_Mac_CF  NULL
#define  Uni2sjisTable_Mac_D0  NULL
#define  Uni2sjisTable_Mac_D1  NULL
#define  Uni2sjisTable_Mac_D2  NULL
#define  Uni2sjisTable_Mac_D3  NULL
#define  Uni2sjisTable_Mac_D4  NULL
#define  Uni2sjisTable_Mac_D5  NULL
#define  Uni2sjisTable_Mac_D6  NULL
#define  Uni2sjisTable_Mac_D7  NULL
#define  Uni2sjisTable_Mac_D8  NULL
#define  Uni2sjisTable_Mac_D9  NULL
#define  Uni2sjisTable_Mac_DA  NULL
#define  Uni2sjisTable_Mac_DB  NULL
#define  Uni2sjisTable_Mac_DC  NULL
#define  Uni2sjisTable_Mac_DD  NULL
#define  Uni2sjisTable_Mac_DE  NULL
#define  Uni2sjisTable_Mac_DF  NULL
#define  Uni2sjisTable_Mac_E0  NULL
#define  Uni2sjisTable_Mac_E1  NULL
#define  Uni2sjisTable_Mac_E2  NULL
#define  Uni2sjisTable_Mac_E3  NULL
#define  Uni2sjisTable_Mac_E4  NULL
#define  Uni2sjisTable_Mac_E5  NULL
#define  Uni2sjisTable_Mac_E6  NULL
#define  Uni2sjisTable_Mac_E7  NULL
#define  Uni2sjisTable_Mac_E8  NULL
#define  Uni2sjisTable_Mac_E9  NULL
#define  Uni2sjisTable_Mac_EA  NULL
#define  Uni2sjisTable_Mac_EB  NULL
#define  Uni2sjisTable_Mac_EC  NULL
#define  Uni2sjisTable_Mac_ED  NULL
#define  Uni2sjisTable_Mac_EE  NULL
#define  Uni2sjisTable_Mac_EF  NULL
#define  Uni2sjisTable_Mac_F0  NULL
#define  Uni2sjisTable_Mac_F1  NULL
#define  Uni2sjisTable_Mac_F2  NULL
#define  Uni2sjisTable_Mac_F3  NULL
#define  Uni2sjisTable_Mac_F4  NULL
#define  Uni2sjisTable_Mac_F5  NULL
#define  Uni2sjisTable_Mac_F6  NULL
#define  Uni2sjisTable_Mac_F7  NULL
#define  Uni2sjisTable_Mac_F8  NULL
#define  Uni2sjisTable_Mac_F9  NULL
#define  Uni2sjisTable_Mac_FA  NULL
#define  Uni2sjisTable_Mac_FB  NULL
#define  Uni2sjisTable_Mac_FC  NULL
#define  Uni2sjisTable_Mac_FD  NULL

static const unsigned short Uni2sjisTable_Mac_FE [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE0x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE1x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE2x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xEB64,  0xEB5C,  0,       0xEB51,  0,       0xEB69,  0xEB6A,  0xEB6F,  // 0xFE3x
      0xEB70,  0xEB6B,  0xEB6C,  0xEB79,  0xEB7A,  0xEB73,  0xEB74,  0xEB71,  
      0xEB72,  0xEB75,  0xEB76,  0xEB77,  0xEB78,  0,       0,       0,       // 0xFE4x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFE9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFECx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFEFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Uni2sjisTable_Mac_FF  NULL


const unsigned short *Uni2sjisTable_Mac ( int C ) {

   static const unsigned short *const Uni2sjisTable_Mac_00_FF [] = {
      Uni2sjisTable_Mac_00, Uni2sjisTable_Mac_01, Uni2sjisTable_Mac_02, Uni2sjisTable_Mac_03,
      Uni2sjisTable_Mac_04, Uni2sjisTable_Mac_05, Uni2sjisTable_Mac_06, Uni2sjisTable_Mac_07,
      Uni2sjisTable_Mac_08, Uni2sjisTable_Mac_09, Uni2sjisTable_Mac_0A, Uni2sjisTable_Mac_0B,
      Uni2sjisTable_Mac_0C, Uni2sjisTable_Mac_0D, Uni2sjisTable_Mac_0E, Uni2sjisTable_Mac_0F,

      Uni2sjisTable_Mac_10, Uni2sjisTable_Mac_11, Uni2sjisTable_Mac_12, Uni2sjisTable_Mac_13,
      Uni2sjisTable_Mac_14, Uni2sjisTable_Mac_15, Uni2sjisTable_Mac_16, Uni2sjisTable_Mac_17,
      Uni2sjisTable_Mac_18, Uni2sjisTable_Mac_19, Uni2sjisTable_Mac_1A, Uni2sjisTable_Mac_1B,
      Uni2sjisTable_Mac_1C, Uni2sjisTable_Mac_1D, Uni2sjisTable_Mac_1E, Uni2sjisTable_Mac_1F,

      Uni2sjisTable_Mac_20, Uni2sjisTable_Mac_21, Uni2sjisTable_Mac_22, Uni2sjisTable_Mac_23,
      Uni2sjisTable_Mac_24, Uni2sjisTable_Mac_25, Uni2sjisTable_Mac_26, Uni2sjisTable_Mac_27,
      Uni2sjisTable_Mac_28, Uni2sjisTable_Mac_29, Uni2sjisTable_Mac_2A, Uni2sjisTable_Mac_2B,
      Uni2sjisTable_Mac_2C, Uni2sjisTable_Mac_2D, Uni2sjisTable_Mac_2E, Uni2sjisTable_Mac_2F,

      Uni2sjisTable_Mac_30, Uni2sjisTable_Mac_31, Uni2sjisTable_Mac_32, Uni2sjisTable_Mac_33,
      Uni2sjisTable_Mac_34, Uni2sjisTable_Mac_35, Uni2sjisTable_Mac_36, Uni2sjisTable_Mac_37,
      Uni2sjisTable_Mac_38, Uni2sjisTable_Mac_39, Uni2sjisTable_Mac_3A, Uni2sjisTable_Mac_3B,
      Uni2sjisTable_Mac_3C, Uni2sjisTable_Mac_3D, Uni2sjisTable_Mac_3E, Uni2sjisTable_Mac_3F,

      Uni2sjisTable_Mac_40, Uni2sjisTable_Mac_41, Uni2sjisTable_Mac_42, Uni2sjisTable_Mac_43,
      Uni2sjisTable_Mac_44, Uni2sjisTable_Mac_45, Uni2sjisTable_Mac_46, Uni2sjisTable_Mac_47,
      Uni2sjisTable_Mac_48, Uni2sjisTable_Mac_49, Uni2sjisTable_Mac_4A, Uni2sjisTable_Mac_4B,
      Uni2sjisTable_Mac_4C, Uni2sjisTable_Mac_4D, Uni2sjisTable_Mac_4E, Uni2sjisTable_Mac_4F,

      Uni2sjisTable_Mac_50, Uni2sjisTable_Mac_51, Uni2sjisTable_Mac_52, Uni2sjisTable_Mac_53,
      Uni2sjisTable_Mac_54, Uni2sjisTable_Mac_55, Uni2sjisTable_Mac_56, Uni2sjisTable_Mac_57,
      Uni2sjisTable_Mac_58, Uni2sjisTable_Mac_59, Uni2sjisTable_Mac_5A, Uni2sjisTable_Mac_5B,
      Uni2sjisTable_Mac_5C, Uni2sjisTable_Mac_5D, Uni2sjisTable_Mac_5E, Uni2sjisTable_Mac_5F,

      Uni2sjisTable_Mac_60, Uni2sjisTable_Mac_61, Uni2sjisTable_Mac_62, Uni2sjisTable_Mac_63,
      Uni2sjisTable_Mac_64, Uni2sjisTable_Mac_65, Uni2sjisTable_Mac_66, Uni2sjisTable_Mac_67,
      Uni2sjisTable_Mac_68, Uni2sjisTable_Mac_69, Uni2sjisTable_Mac_6A, Uni2sjisTable_Mac_6B,
      Uni2sjisTable_Mac_6C, Uni2sjisTable_Mac_6D, Uni2sjisTable_Mac_6E, Uni2sjisTable_Mac_6F,

      Uni2sjisTable_Mac_70, Uni2sjisTable_Mac_71, Uni2sjisTable_Mac_72, Uni2sjisTable_Mac_73,
      Uni2sjisTable_Mac_74, Uni2sjisTable_Mac_75, Uni2sjisTable_Mac_76, Uni2sjisTable_Mac_77,
      Uni2sjisTable_Mac_78, Uni2sjisTable_Mac_79, Uni2sjisTable_Mac_7A, Uni2sjisTable_Mac_7B,
      Uni2sjisTable_Mac_7C, Uni2sjisTable_Mac_7D, Uni2sjisTable_Mac_7E, Uni2sjisTable_Mac_7F,

      Uni2sjisTable_Mac_80, Uni2sjisTable_Mac_81, Uni2sjisTable_Mac_82, Uni2sjisTable_Mac_83,
      Uni2sjisTable_Mac_84, Uni2sjisTable_Mac_85, Uni2sjisTable_Mac_86, Uni2sjisTable_Mac_87,
      Uni2sjisTable_Mac_88, Uni2sjisTable_Mac_89, Uni2sjisTable_Mac_8A, Uni2sjisTable_Mac_8B,
      Uni2sjisTable_Mac_8C, Uni2sjisTable_Mac_8D, Uni2sjisTable_Mac_8E, Uni2sjisTable_Mac_8F,

      Uni2sjisTable_Mac_90, Uni2sjisTable_Mac_91, Uni2sjisTable_Mac_92, Uni2sjisTable_Mac_93,
      Uni2sjisTable_Mac_94, Uni2sjisTable_Mac_95, Uni2sjisTable_Mac_96, Uni2sjisTable_Mac_97,
      Uni2sjisTable_Mac_98, Uni2sjisTable_Mac_99, Uni2sjisTable_Mac_9A, Uni2sjisTable_Mac_9B,
      Uni2sjisTable_Mac_9C, Uni2sjisTable_Mac_9D, Uni2sjisTable_Mac_9E, Uni2sjisTable_Mac_9F,

      Uni2sjisTable_Mac_A0, Uni2sjisTable_Mac_A1, Uni2sjisTable_Mac_A2, Uni2sjisTable_Mac_A3,
      Uni2sjisTable_Mac_A4, Uni2sjisTable_Mac_A5, Uni2sjisTable_Mac_A6, Uni2sjisTable_Mac_A7,
      Uni2sjisTable_Mac_A8, Uni2sjisTable_Mac_A9, Uni2sjisTable_Mac_AA, Uni2sjisTable_Mac_AB,
      Uni2sjisTable_Mac_AC, Uni2sjisTable_Mac_AD, Uni2sjisTable_Mac_AE, Uni2sjisTable_Mac_AF,

      Uni2sjisTable_Mac_B0, Uni2sjisTable_Mac_B1, Uni2sjisTable_Mac_B2, Uni2sjisTable_Mac_B3,
      Uni2sjisTable_Mac_B4, Uni2sjisTable_Mac_B5, Uni2sjisTable_Mac_B6, Uni2sjisTable_Mac_B7,
      Uni2sjisTable_Mac_B8, Uni2sjisTable_Mac_B9, Uni2sjisTable_Mac_BA, Uni2sjisTable_Mac_BB,
      Uni2sjisTable_Mac_BC, Uni2sjisTable_Mac_BD, Uni2sjisTable_Mac_BE, Uni2sjisTable_Mac_BF,

      Uni2sjisTable_Mac_C0, Uni2sjisTable_Mac_C1, Uni2sjisTable_Mac_C2, Uni2sjisTable_Mac_C3,
      Uni2sjisTable_Mac_C4, Uni2sjisTable_Mac_C5, Uni2sjisTable_Mac_C6, Uni2sjisTable_Mac_C7,
      Uni2sjisTable_Mac_C8, Uni2sjisTable_Mac_C9, Uni2sjisTable_Mac_CA, Uni2sjisTable_Mac_CB,
      Uni2sjisTable_Mac_CC, Uni2sjisTable_Mac_CD, Uni2sjisTable_Mac_CE, Uni2sjisTable_Mac_CF,

      Uni2sjisTable_Mac_D0, Uni2sjisTable_Mac_D1, Uni2sjisTable_Mac_D2, Uni2sjisTable_Mac_D3,
      Uni2sjisTable_Mac_D4, Uni2sjisTable_Mac_D5, Uni2sjisTable_Mac_D6, Uni2sjisTable_Mac_D7,
      Uni2sjisTable_Mac_D8, Uni2sjisTable_Mac_D9, Uni2sjisTable_Mac_DA, Uni2sjisTable_Mac_DB,
      Uni2sjisTable_Mac_DC, Uni2sjisTable_Mac_DD, Uni2sjisTable_Mac_DE, Uni2sjisTable_Mac_DF,

      Uni2sjisTable_Mac_E0, Uni2sjisTable_Mac_E1, Uni2sjisTable_Mac_E2, Uni2sjisTable_Mac_E3,
      Uni2sjisTable_Mac_E4, Uni2sjisTable_Mac_E5, Uni2sjisTable_Mac_E6, Uni2sjisTable_Mac_E7,
      Uni2sjisTable_Mac_E8, Uni2sjisTable_Mac_E9, Uni2sjisTable_Mac_EA, Uni2sjisTable_Mac_EB,
      Uni2sjisTable_Mac_EC, Uni2sjisTable_Mac_ED, Uni2sjisTable_Mac_EE, Uni2sjisTable_Mac_EF,

      Uni2sjisTable_Mac_F0, Uni2sjisTable_Mac_F1, Uni2sjisTable_Mac_F2, Uni2sjisTable_Mac_F3,
      Uni2sjisTable_Mac_F4, Uni2sjisTable_Mac_F5, Uni2sjisTable_Mac_F6, Uni2sjisTable_Mac_F7,
      Uni2sjisTable_Mac_F8, Uni2sjisTable_Mac_F9, Uni2sjisTable_Mac_FA, Uni2sjisTable_Mac_FB,
      Uni2sjisTable_Mac_FC, Uni2sjisTable_Mac_FD, Uni2sjisTable_Mac_FE, Uni2sjisTable_Mac_FF,
   } ;

   if ( (unsigned) C <= 0xFF ) return Uni2sjisTable_Mac_00_FF [ C ] ;

   return NULL ;
}


#endif
