// tmpfile.h

#ifndef TMPFILE_H
#define TMPFILE_H

#ifdef __cplusplus
extern "C" {
#endif


int GetTempFileNameExA ( const char *szPrefix, char *szFileName ) ;
int GetTempFileNameExW ( const wchar_t *szPrefix, wchar_t *szFileName ) ;


#ifdef UNICODE
#define GetTempFileNameEx GetTempFileNameExW
#else
#define GetTempFileNameEx GetTempFileNameExA
#endif


#ifdef __cplusplus
}
#endif

#endif


