// oemio.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include <mbctype.h>
#include "msc.h"
#include "oemio.h"



// Unicode  OEM ɑΉXg[o͏

// \n  \r\n ϊ CTRL-Z ւ̑Ή
// ANSI/OEM Xg[Ȃ烉Cu[ɏ
// Unicode Xg[Ȃ玩Oŏ

// fwide () ̑Ή
//    "r", "r+" ͑Ή
//    "w", "w+" ͑Ή
//    "a", "a+" ͖Ή
//    stdin, stdout, stderr ̃R\[o͂͑ΉiȂj
//    stdout, stderr ̃_CNg ">" ͑Ή
//    stdout, stderr ̒ǉ_CNg ">>" ͑Ή
//    stdin ̃_CNg "<" ͑Ή
//    pCv͑Ή

// 
//
// fopen()  "r+", "a+" Ńt@CJƂAeLXgt@CȂAt@CI[̕𒲂ׁA
// ^Z ȂABt@CJƂ "b" w肳Ă΁A̓łB
// Ƃ _setmode() Ń[hύX邩ǂ́A̓Ɋ֌WȂBUnicode ͂QoCg
//  ^Z 邱Ƃ̂ŁA "r+", "a+" ̎gpɂ͒ӂKvB



#define IS_DETECT_SURROGATE   0



//////////////////////////////
//        f[^        //
//////////////////////////////
#if defined _MSC_VER || defined __DMC__ || defined __WATCOMC__ || defined __GNUC__



#define OEMIO_UNICODE_MODE    0x01000000     // Unicode [h
#define OEMIO_TEXT_MODE       0x02000000     // Unicode [hŁAeLXg[h
#define OEMIO_TOUCHED         0x04000000     // łɓo͂sȂ
#define OEMIO_TO_WRITE_BOM    0x08000000     // BOM o͂ipCvł̂ݗLj


#define GET_MODE(stream,bit)        ( stream->_flag & bit )
#define SET_MODE(stream,mode,bit)   ( (mode) ? ( stream->_flag |= bit ) : ( stream->_flag &= ~ bit ) )

#define get_unicode_mode(stream)          GET_MODE ( stream, OEMIO_UNICODE_MODE )
#define set_unicode_mode(stream,mode)     SET_MODE ( stream, mode, OEMIO_UNICODE_MODE )

#define get_text_mode(stream)             GET_MODE ( stream, OEMIO_TEXT_MODE )
#define set_text_mode(stream,mode)        SET_MODE ( stream, mode, OEMIO_TEXT_MODE )

#define get_is_touched(stream)            GET_MODE ( stream, OEMIO_TOUCHED )
#define set_is_touched(stream,mode)       SET_MODE ( stream, mode, OEMIO_TOUCHED )

#define get_is_to_write_bom(stream)       GET_MODE ( stream, OEMIO_TO_WRITE_BOM )
#define set_is_to_write_bom(stream,mode)  SET_MODE ( stream, mode, OEMIO_TO_WRITE_BOM )


// Xg[̃tǑ^ int łȂ΃RpCG[N
static int test_stream_flag_type ( FILE *stream ) { int *p = & stream->_flag ; return *p ; }



#else // defined _MSC_VER || defined __DMC__ || defined __WATCOMC__ || defined __GNUC__



// not supported, dummy

static int get_unicode_mode ( FILE *stream ) { return 0 ; }
static int set_unicode_mode ( FILE *stream, int mode ) { return 0 ; }

static int get_text_mode ( FILE *stream ) { return 0 ; }
static int set_text_mode ( FILE *stream, int mode ) { return 0 ; }

static int get_is_touched ( FILE *stream ) { return 1 ; }
static int set_is_touched ( FILE *stream, int mode ) { return 0 ; }

static int get_is_to_write_bom ( FILE *stream ) { return 0 ; }
static int set_is_to_write_bom ( FILE *stream, int mode ) { return 0 ; }



#endif // else of defined _MSC_VER || defined __DMC__ || defined __WATCOMC__ || defined __GNUC__



//////////////////////////////
//        f[^        //
//////////////////////////////



#if defined _MSC_VER
#define is_read_stream(stream)   ( stream->_flag & ( _IOREAD | _IORW ) )
#else
#define is_read_stream(stream)   0
#endif



//////////////////////////////
//         ʊ֐         //
//////////////////////////////



static int fwide_internal ( FILE *stream, int mode ) ;
static int fgetwc_straight ( FILE *stream ) ;


// ˂̂ FILE_TYPE_REMOTE (0x8000) ͂
#define GetFileType(h)   ( GetFileType ( h ) & ~ FILE_TYPE_REMOTE )



// Xg[ Unicode [hݒ/擾
// mode   Ȃ Ansi [h
//          Ȃ Unicode [h
//         0 Ȃ ݂̃[h擾
// ߂ĺAAnsi [hȂ畉Ԃ
//           Unicode [hȂ琳Ԃ
// ǂݍ݂܂͒ǉ_CNgȂAmode 𖳎At@C擪画f
// [h̕ύX́A܂o͂sȂĂȂXg[ł̂݉\
int fwide ( FILE *stream, int mode ) {

   int result ;

   if ( mode ) result = fwide_internal ( stream, ( mode > 0 ) ? 1 : 0 ) ;
   else        result = fwide_internal ( stream, -1 ) ;

   return ( result ) ? 1 : -1 ;
}



int peek_bom ( FILE *stream ) ;



// fwide ̉֐
// mode  0 Ȃ AnsiAȂ UnicodeAȂ₢킹̂
// Ansi Ȃ 0 AUnicode Ȃ 0 ȊOԂ
static int fwide_internal ( FILE *stream, int mode ) {

   if ( fisatty ( stream ) ) return IsNT () ;
   if ( get_is_touched ( stream ) ) return get_unicode_mode ( stream ) ;
   if ( stream->_base != stream->_ptr ) return get_unicode_mode ( stream ) ;

   int bom_status = peek_bom ( stream ) ;
   if ( bom_status >= 0 ) {
      if ( bom_status ) mode = 1 ;
      else              mode = 0 ;
      set_is_touched ( stream, 1 ) ;
   }

   if ( mode < 0 ) return get_unicode_mode ( stream ) ;

   int oldmode = get_unicode_mode ( stream ) ;
   set_unicode_mode ( stream, mode ) ;
   int newmode = get_unicode_mode ( stream ) ;  // l bool ł͂Ȃ̂ōēx擾Ĕr

   if ( newmode != oldmode ) {
      if ( newmode ) {
         if ( fsetmode ( stream, _O_BINARY ) == _O_TEXT ) {
            set_text_mode ( stream, 1 ) ;
            set_is_to_write_bom ( stream, 1 ) ;
         }
         else {
            set_text_mode ( stream, 0 ) ;
            set_is_to_write_bom ( stream, 0 ) ;
         }
      }
      else {
         if ( get_text_mode ( stream ) ) fsetmode ( stream, _O_TEXT ) ;
         set_unicode_mode ( stream, 0 ) ;
         set_text_mode ( stream, 0 ) ;
         set_is_to_write_bom ( stream, 0 ) ;
      }
   }

   return mode ;
}



// t@C擪 BOM 
// Ansi Ȃ 0 AUnicode Ȃ琳AsȂ畉Ԃ
int peek_bom ( FILE *stream ) {

   int mode = -1 ;

   HANDLE hFile = fget_osfhandle ( stream ) ;
   if ( hFile == INVALID_HANDLE_VALUE ) return mode ;


   // "r", "r+", "w+"
   if ( is_read_stream ( stream ) ) {

      // pipe
      if ( GetFileType ( hFile ) == FILE_TYPE_PIPE ) {

         wchar_t wsz [ 1 ] ;
         unsigned long dwByte ;
         int result ;

         while ( ( result = PeekNamedPipe ( hFile, wsz, sizeof(wchar_t), & dwByte, NULL, NULL ) ) && ! dwByte ) Sleep ( 100 ) ;

         if ( result && dwByte == sizeof(wchar_t) && *wsz == BYTE_ORDER_MARK ) mode = 1 ;
         else if ( dwByte )                                                    mode = 0 ;

      }
      // file
      else if ( ! ftell64 ( stream ) ) {

         fseek64 ( stream, 0, SEEK_SET ) ;

         int oldmode = fsetmode ( stream, _O_BINARY ) ;

         int c = fgetwc_straight ( stream ) ;
         if ( c == BYTE_ORDER_MARK ) mode = 1 ;
         else if ( c != EOF )        mode = 0 ;

         fseek64 ( stream, 0, SEEK_SET ) ;
         fsetmode ( stream, oldmode ) ;

      }

   }
   // ǉ_CNg
   else if ( stream == stdout || stream == stderr ) {

      if ( GetFileType ( hFile ) == FILE_TYPE_DISK ) {

         int64_t position = ftell64 ( stream ) ;
         if ( position && position != -1 ) {

            HANDLE hTmp ;

            if ( DuplicateHandle ( GetCurrentProcess (), hFile, GetCurrentProcess (), & hTmp, GENERIC_READ, 0, 0 ) ) {

               if ( SetFilePointer ( hTmp, 0, NULL, FILE_BEGIN ) != INVALID_SET_FILE_POINTER ) {

                  wchar_t wsz [ 1 ] ;
                  unsigned long dwByte ;

                  if ( ReadFile ( hTmp, wsz, sizeof(wchar_t), & dwByte, NULL ) ) {
                     if ( dwByte == sizeof(wchar_t) && *wsz == BYTE_ORDER_MARK ) mode = 1 ;
                     else if ( dwByte )                                          mode = 0 ;
                  }
               }

               CloseHandle ( hTmp ) ;
            }

            fseek64 ( stream, position, SEEK_SET ) ;
         }
      }
   }


   return mode ;
}



//////////////////////////////
//      o̓[eB      //
//////////////////////////////



// eLXg[h   { Ansi [h   FLFCR+LF
//                  { Console [hFLFCR+LF
//                  { Unicode [hFLFCR+LF, 擪 BOM o
// oCi[[h { Ansi [h   FLF}}
//                  { Console [hFLF}}
//                  { Unicode [hFLF}}, 擪 BOM o͂



#if ! defined _MSC_VER || _MSC_VER < 1300
static int __cdecl vscprintf ( const char *format, va_list args ) ;
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) ;
#else
#define vscprintf _vscprintf
#define vscwprintf _vscwprintf
#endif


static size_t fwrites_internal ( const char *string, size_t count, FILE *stream ) ;
static size_t fwritews_internal ( const wchar_t *string, size_t count, FILE *stream ) ;

#define TMP_BUFFER_SIZE    ( MAX_PATH + 0x10 )


#undef printf
#undef fprintf
#undef vfprintf
#undef fputs

#undef wprintf
#undef fwprintf
#undef vfwprintf
#undef fputws



//////////////////////////////
//          ANSI          //
//////////////////////////////



// ߂l fwrite ƓiԂj
size_t __cdecl oem_fwrites ( const char *string, size_t length, FILE *stream ) {

   set_is_touched ( stream, 1 ) ;
   if ( fisatty ( stream ) ? GetACP () == GetConsoleOutputCP () : ! get_unicode_mode ( stream ) ) return fwrite ( string, sizeof(char), length, stream ) / sizeof(char) ;

   return fwrites_internal ( string, length, stream ) ;
}



// ߂l fputs Ɠ
int __cdecl oem_fputs ( const char *string, FILE *stream ) {

   size_t length = strlen ( string ) ;

   if ( oem_fwrites ( string, length, stream ) != length ) return EOF ;

   return 0 ;
}



// ߂l printf Ɠ
int __cdecl oem_printf ( const char *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfprintf ( stdout, format, args ) ;

   va_end ( args ) ;

   return retvalue ;
}



// ߂l fprintf Ɠ
int __cdecl oem_fprintf ( FILE *stream, const char *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfprintf ( stream, format, args ) ;

   va_end ( args ) ;

   return retvalue ;
}



// ߂l vfprintf Ɠ
int __cdecl oem_vfprintf ( FILE *stream, const char *format, va_list args ) {

   set_is_touched ( stream, 1 ) ;
   if ( fisatty ( stream ) ? GetACP () == GetConsoleOutputCP () : ! get_unicode_mode ( stream ) ) return vfprintf ( stream, format, args ) ;

   int retvalue = EOF ;

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   char buffer [ TMP_BUFFER_SIZE ] ;
   char *string = NULL ;
   int result ;

   if ( ( result = vsnprintf ( buffer, TMP_BUFFER_SIZE, format, args ) ) < 0 || result > TMP_BUFFER_SIZE - 1 ) {

      int length ;
      if ( ( length = vscprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (char*) malloc ( ( length + 1 ) * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;
   }

   if ( fwrites_internal ( ( string ) ? string : buffer, result, stream ) == (size_t) result ) retvalue = result ;

   CAUGHT_ERROR :

   free ( string ) ;

   va_end ( args1 ) ;
   va_end ( args2 ) ;

   return retvalue ;
}



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscprintf ( const char *format, va_list args ) {

   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;

   int retvalue = vfprintf ( stdnul, format, args ) ;

   fclose ( stdnul ) ;

   return retvalue ;
}
#endif



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// ߂l fwrite ƓiԂj
size_t __cdecl oem_fwritews ( const wchar_t *string, size_t length, FILE *stream ) {

   set_is_touched ( stream, 1 ) ;
   if ( get_unicode_mode ( stream ) && ! get_text_mode ( stream ) ) return fwrite ( string, sizeof(wchar_t), length, stream ) / sizeof(wchar_t) ;

   return fwritews_internal ( string, length, stream ) ;
}



// ߂l fputws Ɠ
int __cdecl oem_fputws ( const wchar_t *string, FILE *stream ) {

   size_t length = wcslen ( string ) ;

   if ( oem_fwritews ( string, length, stream ) != length ) return EOF ;

   return 0 ;
}



// ߂l wprintf Ɠ
int __cdecl oem_wprintf ( const wchar_t *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfwprintf ( stdout, format, args ) ;

   va_end ( args ) ;

   return retvalue ;
}



// ߂l fwprintf Ɠ
int __cdecl oem_fwprintf ( FILE *stream, const wchar_t *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfwprintf ( stream, format, args ) ;

   va_end ( args ) ;

   return retvalue ;
}



// ߂l vfwprintf Ɠ
int __cdecl oem_vfwprintf ( FILE *stream, const wchar_t *format, va_list args ) {

   set_is_touched ( stream, 1 ) ;
   if ( get_unicode_mode ( stream ) && ! get_text_mode ( stream ) ) return vfwprintf ( stream, format, args ) ;

   int retvalue = EOF ;

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   wchar_t buffer [ TMP_BUFFER_SIZE ] ;
   wchar_t *string = NULL ;
   int result ;

   if ( ( result = vsnwprintf ( buffer, TMP_BUFFER_SIZE, format, args ) ) < 0 || result > TMP_BUFFER_SIZE - 1 ) {

      int length ;
      if ( ( length = vscwprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (wchar_t*) malloc ( ( length + 1 ) * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnwprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;
   }

   if ( fwritews_internal ( ( string ) ? string : buffer, result, stream ) == (size_t) result ) retvalue = result ;

   CAUGHT_ERROR :

   free ( string ) ;

   va_end ( args1 ) ;
   va_end ( args2 ) ;

   return retvalue ;
}



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) {

   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;

   int retvalue = vfwprintf ( stdnul, format, args ) ;

   fclose ( stdnul ) ;

   return retvalue ;
}
#endif



//////////////////////////////
//         ֐         //
//////////////////////////////



static int fputwc_straight ( int c, FILE *stream ) ;
static inline void fseterror ( FILE *stream ) ;



// o͂Ԃ
static size_t fwrites_internal ( const char *string, size_t count, FILE *stream ) {

   size_t count_saved = count ;

   for ( ; count ; string ++, count -- ) {

      wchar_t wsz [ 1 ] ;
      int length = 1 ;

      if ( isascii ( *string ) ) {     // ̂
         wsz [ 0 ] = (unsigned char) *string ;
      }
      else {
         if ( ismbblead ( (unsigned char) *string ) && *( string + 1 ) ) length = 2 ;
         if ( ! MultiByteToWideChar ( CP_ACP, 0, string, length, wsz, 1 ) ) break ;
      }

      if ( ! fwritews_internal ( wsz, 1, stream ) ) break ;
      if ( length > 1 ) string ++, count -- ;
   }

   return count_saved - count ;
}



// o͂Ԃ
static size_t fwritews_internal ( const wchar_t *string, size_t count, FILE *stream ) {

   int codepage = CP_ACP ;

   if ( fisatty ( stream ) ) {
      if ( IsNT () ) {

         HANDLE hConsole = fget_osfhandle ( stream ) ;
         if ( hConsole == INVALID_HANDLE_VALUE ) return 0 ;

         unsigned long dwDummy ;

         if ( GetConsoleMode ( hConsole, & dwDummy ) ) {

            fflush ( stream ) ;
            size_t count_saved = count ;

            while ( count ) {
               unsigned long dwCharToWrite = ( count == (size_t) (unsigned char) count ) ? (unsigned char) count : ( UCHAR_MAX + 1 ) ;
               unsigned long dwCharWritten = 0 ;
               if ( ! WriteConsoleW ( hConsole, string, dwCharToWrite, & dwCharWritten, NULL ) || ! dwCharWritten || count < dwCharWritten ) {
                  fseterror ( stream ) ;
                  break ;
               }
               count -= dwCharWritten ;
               string += dwCharWritten ;
            }

            return count_saved - count ;
         }

      }
      codepage = GetConsoleOutputCP () ;
   }


   if ( get_unicode_mode ( stream ) ) {

      size_t count_saved = count ;
      int is_output_bom = 0 ;
      int is_text_mode = get_text_mode ( stream ) ;

      if ( is_text_mode && stream->_base == stream->_ptr ) {

         HANDLE hFile = fget_osfhandle ( stream ) ;
         if ( hFile == INVALID_HANDLE_VALUE ) return 0 ;

         // pipe
         if ( GetFileType ( hFile ) == FILE_TYPE_PIPE ) {
            if ( get_is_to_write_bom ( stream ) ) is_output_bom = 1 ;
            set_is_to_write_bom ( stream, 0 ) ;
         }
         // file
         else {
            if ( ! ftell64 ( stream ) ) is_output_bom = 1 ;
         }

      }

      if ( is_output_bom && fputwc_straight ( BYTE_ORDER_MARK, stream ) < 0 ) return 0 ;

      for ( ; count ; string ++, count -- ) {
         int c = *string ;
         if ( is_text_mode ) {
            if ( c == BYTE_ORDER_MARK || c == WEOF ) continue ;
            if ( c == '\n' ) fputwc_straight ( '\r', stream ) ;
         }
         if ( fputwc_straight ( c, stream ) < 0 ) break ;
      }

      return count_saved - count ;
   }


   size_t count_saved = count ;

   for ( ; count ; string ++, count -- ) {

      char sz [ MB_LEN_MAX ] ;
      int length ;

      if ( isascii ( *string ) ) {     // ̂
         sz [ 0 ] = (unsigned char) *string ;
         length = 1 ;
      }
      else if ( IS_DETECT_SURROGATE && IsUnicodeHighSurrogate ( *string ) ) {
         if ( ! ( length = WideCharToMultiByte ( codepage, 0, string, 2, sz, MB_LEN_MAX, NULL, NULL ) ) ) break ;
         if ( length == 2 && sz [ 0 ] == '?' && sz [ 1 ] == '?' ) length = 1 ;
         string ++, count -- ;
      }
      else {
         if ( ! ( length = WideCharToMultiByte ( codepage, 0, string, 1, sz, MB_LEN_MAX, NULL, NULL ) ) ) break ;
      }

      for ( int i = 0 ; i < length ; i ++ ) {
         if ( fputc ( (unsigned char) sz [ i ], stream ) < 0 ) goto EXIT_LOOP ;
      }
   }

   EXIT_LOOP :

   return count_saved - count ;
}



//////////////////////////////
//      ̓[eB      //
//////////////////////////////



// eLXg[h   { Ansi [h   FCR+LFLF, CTRL-Z Ńt@CI[
//                  { Console [hFCR+LFLF, s CTRL-Z Ńt@CI[
//                  { Unicode [hFCR+LFLF,  BOM 𖳎
// oCi[[h { Ansi [h   FCR+LF}}, CTRL-Z ̓}}
//                  { Console [hFCR+LF}}, s CTRL-Z Ńt@CI[
//                  { Unicode [hFCR+LF}}, BOM ̓}}



static size_t freads_internal ( char *string, size_t count, int stop_char, FILE *stream ) ;
static size_t freadws_internal ( wchar_t *string, size_t count, int stop_char, FILE *stream ) ;
static int fgetc_internal ( FILE *stream, int is_unicode_mode, int codepage ) ;
static int fgetwc_internal ( FILE *stream, int is_unicode_mode, int codepage ) ;

#define CTRLZ     0x1A

#undef fgets
#undef fgetws



//////////////////////////////
//          ANSI          //
//////////////////////////////



// ߂l fread ƓioCgԂj
// eLXg[h܂͂QoCgł͂P`QȂƂ
// obt@EłQoCgQɊ邱Ƃ͂Ȃ
// eLXg[hł̓k폜
size_t __cdecl oem_freads ( char *string, size_t count, FILE *stream ) {

   return freads_internal ( string, count, EOF, stream ) ;
}



// ߂l fgets Ɠ
// eLXg[h܂͂QoCgł͂P`QȂƂ
// obt@EłQoCgQɊ邱Ƃ͂Ȃ
// eLXg[hł̓k폜
char *__cdecl oem_fgets ( char *string, int count, FILE *stream ) {

   if ( count <= 0 ) return NULL ;

   size_t retvalue = freads_internal ( string, count - 1, '\n', stream ) ;
   string [ retvalue ] = 0 ;

   if ( ! retvalue && feof ( stream ) ) return NULL ;
   return string ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// ߂l fread Ɠi[hԂj
// eLXg[hł͂PȂƂ
// eLXg[hł̓k폜
size_t __cdecl oem_freadws ( wchar_t *string, size_t count, FILE *stream ) {

   return freadws_internal ( string, count, EOF, stream ) ;
}



// ߂l fgetws Ɠ
// eLXg[hł͂PȂƂ
// eLXg[hł̓k폜
wchar_t *__cdecl oem_fgetws ( wchar_t *string, int count, FILE *stream ) {

   if ( count <= 0 ) return NULL ;

   size_t retvalue = freadws_internal ( string, count - 1, '\n', stream ) ;
   string [ retvalue ] = 0 ;

   if ( ! retvalue && feof ( stream ) ) return NULL ;
   return string ;
}



//////////////////////////////
//         ֐         //
//////////////////////////////



#define getmbcp _getmbcp   // if single-byte cp, then return 0
static inline void fseteof ( FILE *stream ) ;



// ͂Ԃ
static size_t freads_internal ( char *string, size_t count, int stop_char, FILE *stream ) {

   set_is_touched ( stream, 1 ) ;
   int is_unicode_mode = get_unicode_mode ( stream ) ;
   int is_text_mode = ( is_unicode_mode ) ? get_text_mode ( stream ) : 0 ;

   int codepage = CP_ACP ;
   if ( fisatty ( stream ) && GetACP () != GetConsoleCP () ) codepage = GetConsoleCP () ;


   char *current = string ;
   char *end = string + count ;
   int is_first_in_line = 1 ;


   // R\[ȂꎞIɃoCi[[h
   int old_mode = 0 ;
   if ( fisatty ( stream ) ) {
      old_mode = fsetmode ( stream, _O_BINARY ) ;
      if ( old_mode == _O_TEXT ) is_text_mode = 1 ;
   }


   // \r ܂ trail byte ޏꍇɔ
   if ( is_text_mode ) end -- ;
   if ( getmbcp () ) end -- ;


   while ( current < end ) {

      int c ;

      if ( ( c = fgetc_internal ( stream, is_unicode_mode, codepage ) ) < 0 ) break ;

      if ( c == CTRLZ && is_first_in_line && fisatty ( stream ) ) {
         while ( ( c = fgetc_internal ( stream, is_unicode_mode, codepage ) ) >= 0 && c != '\n' ) ;
         fseteof ( stream ) ;
         break ;
      }

      if ( is_text_mode ) {
         if ( c == '\r' ) {
            c = fgetc_internal ( stream, is_unicode_mode, codepage ) ;
            if ( c != '\n' ) *current ++ = '\r' ;
            if ( c < 0 ) break ;
         }
         if ( c == 0 ) continue ;
      }

      if ( c > 0x100 ) {
         *current ++ = (unsigned char) ( c >> 8 ) ;
         *current ++ = (unsigned char) c ;
      }
      else {
         *current ++ = (unsigned char) c ;
      }

      if ( c == '\n' ) is_first_in_line = 1 ;
      else             is_first_in_line = 0 ;

      if ( c == stop_char ) break ;
   }


   if ( fisatty ( stream ) ) fsetmode ( stream, old_mode ) ;
   return current - string ;
}



// ͂Ԃ
static size_t freadws_internal ( wchar_t *string, size_t count, int stop_char, FILE *stream ) {

   set_is_touched ( stream, 1 ) ;
   int is_unicode_mode = get_unicode_mode ( stream ) ;
   int is_text_mode = ( is_unicode_mode ) ? get_text_mode ( stream ) : 0 ;

   int codepage = CP_ACP ;
   if ( fisatty ( stream ) && GetACP () != GetConsoleCP () ) codepage = GetConsoleCP () ;


   wchar_t *current = string ;
   wchar_t *end = string + count ;
   int is_first_in_line = 1 ;


   // R\[ȂꎞIɃoCi[[h
   int old_mode = 0 ;
   if ( fisatty ( stream ) ) {
      old_mode = fsetmode ( stream, _O_BINARY ) ;
      if ( old_mode == _O_TEXT ) is_text_mode = 1 ;
   }


   // \r ޏꍇɔ
   if ( is_text_mode ) end -- ;


   while ( current < end ) {

      int c ;

      if ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) < 0 ) break ;

      if ( c == CTRLZ && is_first_in_line && fisatty ( stream ) ) {
         while ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) >= 0 && c != '\n' ) ;
         fseteof ( stream ) ;
         break ;
      }

      if ( is_text_mode ) {
         if ( c == '\r' ) {
            c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ;
            if ( c != '\n' ) *current ++ = '\r' ;
            if ( c < 0 ) break ;
         }
         if ( c == 0 ) continue ;
         if ( c == BYTE_ORDER_MARK || c == WEOF ) continue ;
      }

      *current ++ = (wchar_t) c ;

      if ( c == '\n' ) is_first_in_line = 1 ;
      else             is_first_in_line = 0 ;

      if ( c == stop_char ) break ;
   }


   if ( fisatty ( stream ) ) fsetmode ( stream, old_mode ) ;
   return current - string ;
}



// 當As EOF Ԃ
static int fgetc_internal ( FILE *stream, int is_unicode_mode, int codepage ) {

   if ( ! is_unicode_mode && codepage == CP_ACP ) {

      int c ;
      if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;

      if ( ismbblead ( c ) ) {
         int c2 ;
         if ( ( c2 = fgetc ( stream ) ) < 0 ) return EOF ;
         c = ( c << 8 ) + c2 ;
      }

      return c ;
   }
   else {

      char sz [ MB_LEN_MAX ] ;
      wchar_t wsz [ 1 ] ;
      int c ;

      while ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) == BYTE_ORDER_MARK || c == WEOF ) ;

      if ( c < 0 ) return EOF ;

      if ( isascii ( c ) ) return c ;     // ̂

      wsz [ 0 ] = (wchar_t) c ;

      int size = WideCharToMultiByte ( CP_ACP, 0, wsz, 1, sz, MB_LEN_MAX, NULL, NULL ) ;
      if ( ! size ) return EOF ;

      if ( size == 2 ) {
         int c1 = (unsigned char) *sz ;
         int c2 = (unsigned char) *( sz + 1 ) ;
         return ( c1 << 8 ) + c2 ;
      }
      else {
         return (unsigned char) *sz ;
      }
   }
}



// 當As EOF Ԃ
static int fgetwc_internal ( FILE *stream, int is_unicode_mode, int codepage ) {

   if ( fisatty ( stream ) ) {
      if ( IsNT () ) {

         HANDLE hConsole = fget_osfhandle ( stream ) ;
         if ( hConsole == INVALID_HANDLE_VALUE ) return EOF ;

         unsigned long dwDummy ;

         if ( GetConsoleMode ( hConsole, & dwDummy ) ) {

            wchar_t wsz [ 1 ] ;
            unsigned long dwCharRead = 0 ;

            if ( ReadConsoleW ( hConsole, wsz, 1, & dwCharRead, NULL ) && dwCharRead ) return *wsz ;

            fseterror ( stream ) ;
            return EOF ;
         }

      }
   }

   if ( is_unicode_mode ) {

      return fgetwc_straight ( stream ) ;

   }
   else {

      char sz [ MB_LEN_MAX ] ;
      wchar_t wsz [ 1 ] ;
      int length ;
      int c ;

      if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;

      if ( isascii ( c ) ) return c ;     // ̂

      if ( IsDBCSLeadByteEx ( codepage, (unsigned char) c ) ) {
         sz [ 0 ] = (unsigned char) c ;
         if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;
         sz [ 1 ] = (unsigned char) c ;
         length = 2 ;
      }
      else {
         sz [ 0 ] = (unsigned char) c ;
         length = 1 ;
      }

      int size = MultiByteToWideChar ( codepage, 0, sz, length, wsz, 1 ) ;
      if ( ! size ) return EOF ;

      return *wsz ;
   }
}



#ifdef __BORLANDC__
#define _flag  flags
#define _IOEOF _F_EOF
#define _IOERR _F_ERR
#endif

#ifdef __WATCOMC__
#define _IOEOF _EOF
#define _IOERR _SFERR
#endif



static inline void fseteof ( FILE *stream ) {
   stream->_flag |= _IOEOF ;
}



static inline void fseterror ( FILE *stream ) {
   stream->_flag |= _IOERR ;
}



//////////////////////////////
//         ֐         //
//////////////////////////////



// 當As EOF Ԃ
static int fputwc_straight ( int c, FILE *stream ) {
   if ( fputc ( (unsigned char) c, stream ) < 0 ) return EOF ;
   if ( fputc ( (unsigned char)( c >> 8 ), stream ) < 0 ) return EOF ;
   return c ;
}



// 當As EOF Ԃ
static int fgetwc_straight ( FILE *stream ) {
   int c1, c2 ;
   if ( ( c1 = fgetc ( stream ) ) < 0 ) return EOF ;
   if ( ( c2 = fgetc ( stream ) ) < 0 ) return EOF ;
   return ( c2 << 8 ) + c1 ;
}



//////////////////////////////
//   R\[ɂPs\   //
//////////////////////////////



// R\[ɂPŝݕ\
// R\[łȂΉȂ
// \Ԃ
int fputs_line ( const char *string, FILE *stream ) {

   if ( ! fisatty ( stream ) ) return 0 ;

   HANDLE hConsole = fget_osfhandle ( stream ) ;
   if ( hConsole == INVALID_HANDLE_VALUE ) return 0 ;

   CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
   if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) return 0 ;
   int width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;

   const char *current = string ;
   const char *start = string ;

   while ( *current ) {

      int char_width = 1 ;
      int isdoublebyte = ismbblead ( *current ) ;

      if ( *current == '\n' || *current == '\f' || *current == '\v' ) break ;
      if ( *current == '\t' ) char_width = 8 ;
      if ( *current == '\r' || *current == '\b' || *current == '\a' ) char_width = 0 ;
      if ( isdoublebyte ) char_width = 2 ;

      width -= char_width ;

      if ( width < 1 ) {

         oem_fwrites ( string, current - string, stream ) ;
         string = current ;

         CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
         if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) break ;
         width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;
         width -= char_width ;

         if ( width < 1 ) break ;
      }

      if ( isdoublebyte && *( current + 1 ) ) current ++ ;
      current ++ ;
   }

   if ( width >= 1 ) oem_fwrites ( string, current - string, stream ) ;

   return (int) ( current - start ) ;
}



// R\[ɂPŝݕ\
// R\[łȂΉȂ
// \Ԃ
int fputws_line ( const wchar_t *string, FILE *stream ) {

   if ( ! fisatty ( stream ) ) return 0 ;

   HANDLE hConsole = fget_osfhandle ( stream ) ;
   if ( hConsole == INVALID_HANDLE_VALUE ) return 0 ;

   CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
   if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) return 0 ;
   int width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;

   const wchar_t *current = string ;
   const wchar_t *start = string ;

   while ( *current ) {

      int char_width = 1 ;
      int isdoublebyte = ! isascii ( *current ) ;

      if ( *current == '\n' || *current == '\f' || *current == '\v' ) break ;
      if ( *current == '\t' ) char_width = 8 ;
      if ( *current == '\r' || *current == '\b' || *current == '\a' ) char_width = 0 ;
      if ( isdoublebyte ) char_width = 2 ;

      width -= char_width ;

      if ( width < 1 ) {

         oem_fwritews ( string, current - string, stream ) ;
         string = current ;

         CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
         if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) break ;
         width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;
         width -= char_width ;

         if ( width < 1 ) break ;
      }

      current ++ ;
   }

   if ( width >= 1 ) oem_fwritews ( string, current - string, stream ) ;

   return (int) ( current - start ) ;
}



