// setup_r.h

#ifndef SETUP_R_H
#define SETUP_R_H


typedef struct {
   const char *A ;
   const wchar_t *W ;
} STRING_A_W ;


#define EXPAND_A_W(s)   { s, L##s }



static const STRING_A_W InstallFileName [] = {
   EXPAND_A_W ( "rtfconv.exe" ),       // KŏɃt@C
   EXPAND_A_W ( "rtfconv.com" ),       // KQԖڂ
   EXPAND_A_W ( "rtfconv.dll" ),       // KRԖڂ
   EXPAND_A_W ( "loadcmd.exe" ),       // KSԖڂ
   EXPAND_A_W ( "mbctbl.dll" ),
   EXPAND_A_W ( "sbctbl.dll" ),
   EXPAND_A_W ( "cnstbl.dll" ),
   EXPAND_A_W ( "setup.exe" ),
   EXPAND_A_W ( "rtfconv-j.html" ),
   EXPAND_A_W ( "rtfconv-e.html" ),
   EXPAND_A_W ( "cjk.html" ),
   EXPAND_A_W ( "lang\\rtfc_chs.dll" ),
   EXPAND_A_W ( "lang\\rtfc_cht.dll" ),
   EXPAND_A_W ( "lang\\rtfc_kor.dll" ),
   { NULL, NULL }
} ;



static const STRING_A_W OldFileName [] = {
   EXPAND_A_W ( "install.exe" ),
   EXPAND_A_W ( "rtf2txt.exe" ),
   EXPAND_A_W ( "txt2rtf.exe" ),
   EXPAND_A_W ( "txt2txt.exe" ),
   EXPAND_A_W ( "rtfconve.html" ),
   EXPAND_A_W ( "rtfconv.html" ),
   EXPAND_A_W ( "rtfconv.txt" ),
   EXPAND_A_W ( "readme.txt" ),
   EXPAND_A_W ( "setrcp.bat" ),
   EXPAND_A_W ( "readme-j.txt" ),
   EXPAND_A_W ( "readme-e.txt" ),
   EXPAND_A_W ( "version.txt" ),
   EXPAND_A_W ( "oldbat.zip" ),
   { NULL, NULL }
} ;



static const STRING_A_W OldBatFileName [] = {
   EXPAND_A_W ( "rtf2txt.bat" ),
   EXPAND_A_W ( "txt2rtf.bat" ),
   EXPAND_A_W ( "txt2txt.bat" ),
   { NULL, NULL }
} ;


static const STRING_A_W LangDllFolder = EXPAND_A_W ( "\\lang" ) ;
static const STRING_A_W OldStartMenuFolder = EXPAND_A_W ( "Harigaya's Converter" ) ;



#endif

